unit JenwayBeer;

interface

uses Windows, Classes, Graphics, Forms, Controls, Menus,
  Dialogs, StdCtrls, Buttons, ExtCtrls, sysUtils, Messages, clipBrd,
  spin, grids, inifiles,
  ADport, ADexcept, oomisc,
  graphker, jmmUtil, CfgSpect, ComCtrls, ToolWin;

type
  TModeAcquisition = (maIncrement,maBeer,maClavier);

  TBeerForm = class(TForm)
    SaveDialog: TSaveDialog;
    BoutonsPanel: TPanel;
    Panel1: TPanel;
    LabelPb: TLabel;
    Oscillo: TPaintBox;
    ClavierEdit: TEdit;
    LabelClavier: TLabel;
    BeerMesureGrid: TStringGrid;
    beerCalcGrid: TStringGrid;
    LambdaSE: TSpinEdit;
    Label2: TLabel;
    Timer: TTimer;
    ToolBar1: TToolBar;
    SaveBtn: TToolButton;
    ModeBtn0: TToolButton;
    ResetBtn: TToolButton;
    UndoBtn: TToolButton;
    EnregistreBtn: TToolButton;
    MajBtn: TToolButton;
    ZeroBtn: TToolButton;
    ExitBtn0: TToolButton;
    PrintBtn0: TToolButton;
    SavePopupMenu: TPopupMenu;
    RegressiM: TMenuItem;
    ClipM: TMenuItem;
    FileM: TMenuItem;
    procedure ExitItemClick(Sender: TObject);
    procedure AboutItemClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure InitAttente;
    procedure AcquisitionItemClick(Sender: TObject);
    procedure OscilloPaint(Sender: TObject);
    procedure StopBtnClick(Sender: TObject);
    procedure ResetBtnClick(Sender: TObject);
    procedure EnregistreEditKeyPress(Sender: TObject; var Key: Char);
    procedure EnregistreBtnClick(Sender: TObject);
    procedure UndoBtnClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure ClavierEditKeyPress(Sender: TObject; var Key: Char);
    procedure LambdaSEChange(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
    procedure MajBtnClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormActivate(Sender: TObject);
    procedure ZeroBtnClick(Sender: TObject);
    procedure PrintBtnClick(Sender: TObject);
    procedure BeerMesureGridSelectCell(Sender: TObject; ACol,
      ARow: Integer; var CanSelect: Boolean);
    procedure BeerMesureGridKeyPress(Sender: TObject; var Key: Char);
    procedure BeerMesureGridSetEditText(Sender: TObject; ACol,
      ARow: Integer; const Value: String);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure SaveBtnClick(Sender: TObject);
    procedure RegressiMClick(Sender: TObject);
  private
    nomFichierIni : string;
    DejaSauve : boolean;
    NomFichierData : string;
    valeurCourante,valeurClavier : double;
    pente : double;
    TitreEcart : shortString;
    AbsCalc,ConcCalc : vecteur;
    NbreCalc : integer;
    DernierPointCalc : boolean;
    { Calc : calcule par la loi de Beer Lambert }
    Procedure FinLambda;
    Procedure setBoutonAcq;
    Procedure MarquePoint(i : indiceVecteur);
    procedure EnvoieDonnees(DDE : boolean);
    procedure SaveItem;
  public
      ModeAcq  : TmodeAcquisition;
      concMax : double;
      Graphe : Tgraphe;
  protected
  end;

var
  BeerForm: TBeerForm;

implementation

uses About, SpectDDE, SpecMain, modebeer, JenwayConst;

{$R *.DFM}

const TimeOutms = 2000;

procedure TBeerForm.ExitItemClick(Sender: TObject);
begin
    SpectreMain.setMode(mNone);
    Close
end;

procedure TBeerForm.SaveItem;
var fichier : textFile;

Procedure EcritPageRW3;
var j : integer;
begin with graphe do begin
    writeln(fichier,symbReg,1,' PAGE COMMENT');
    writeln(fichier,'Cintique'+DateTimeToStr(date+time));
    writeln(fichier,symbReg2,NbrePoints,' VALEUR VAR');
    for j := 0 to pred(NbrePoints) do begin
        write(fichier,FloatToStrPoint(valeurX[j]));
        write(fichier,' ',FloatToStrPoint(valeurY[j]));
        writeln(fichier);
    end; { for j }
end end; {ecritPageRW3}

Procedure EcritPageTableur;
var j : integer;
begin with graphe do begin
    for j := 0 to pred(NbrePoints) do begin
  	write(fichier,FloatToStrPoint(valeurX[j]));
  	write(fichier,crTab,FloatToStrPoint(valeurY[j]));
  	writeln(fichier);
    end;
end end; {ecritPageTableur}

Procedure ecritEnTeteTableur;
begin with graphe do begin
   writeln(fichier,'Cintique');
   write(fichier,mondeX.nom);
   write(crTab,mondeY.nom);
   writeln(fichier);
   write(fichier,mondeX.unite);
   write(crTab,mondeY.Unite);
   writeln(fichier);
   write(fichier,mondeX.signif);
   write(crTab,mondeY.signif);
   writeln(fichier);
end end; { ecritEnTeteTableur }

Procedure ecritEnTeteRW3;
begin with graphe do begin
   writeln(fichier,'EVARISTE REGRESSI WINDOWS 1.0');
   writeln(fichier,symbReg,'2 NOM VAR');
   writeln(fichier,mondeX.nom);
   writeln(fichier,mondeY.nom);
   writeln(fichier,symbReg,'2 UNITE VAR');
   writeln(fichier,mondeX.unite);
   writeln(fichier,mondeY.Unite);
   writeln(fichier,symbReg,'2 SIGNIF VAR');
   writeln(fichier,mondeX.signif);
   writeln(fichier,mondeY.signif);
   writeln(fichier,symbReg,'1 ACQUISITION');
   writeln(fichier,Application.ExeName)
end end; { ecritEnTeteRW3 }

var formatRW3 : boolean;
begin
     SaveDialog.filter := 'Regressi (*.rw3)|*.rw3|Tableur ASCII (*.txt)|*.txt';
     SaveDialog.defaultExt := 'RW3';
     if SaveDialog.Execute then begin
         FormatRW3 := ExtractFileExt(saveDialog.FileName)='.RW3';
         NomFichierData := saveDialog.FileName;
         AssignFile(fichier,saveDialog.FileName);
         Rewrite(fichier);
         if formatRW3
            then begin
               ecritEnTeteRW3;
               ecritPageRW3;
            end
            else begin
               ecritEnTeteTableur;
               ecritPageTableur;
            end;
         CloseFile(fichier);
         DejaSauve := true;
     end;
end;

procedure TBeerForm.AboutItemClick(Sender: TObject);
begin
    AboutBox.ShowModal
end;

procedure TBeerForm.FormCreate(Sender: TObject);
var regini : TmemIniFile;
begin
  nomFichierIni := changeFileExt(application.exeName,'.ini');
  DejaSauve := true;
  ModeAcq := maIncrement;
  Graphe := Tgraphe.Create;
  Graphe.etatSpectre := esAbsorbance;
  with graphe.mondeY do begin
     nom := 'A';
     unite := '';
     signif := 'Absorbance';
     mini := 0;
     maxi := 1;
  end;
  with graphe do begin
     Trace := tCinet;
     limiteCourbe := Oscillo.clientRect;
     Canvas := Oscillo.Canvas;
     NbrePoints := 0;
  end;
  NbreCalc := 0;
  LambdaSE.minValue := Spectro.miniLambda;
  LambdaSE.maxValue := Spectro.maxiLambda;
  LambdaSE.value := 500;
  BeerCalcGrid.font.color := couleurCalc;
  try
  RegIni := tMemIniFile.create(NomFichierIni);
  regressiM.Checked := regIni.ReadBool('Save','Regressi',true);
  if regressiM.Checked then
     saveBtn.ImageIndex := regressiM.imageIndex;
  clipM.Checked := regIni.ReadBool('Save','Clip',false);
  if clipM.Checked then
     saveBtn.ImageIndex := clipM.imageIndex;
  fileM.Checked := regIni.ReadBool('Save','File',false);
  if fileM.Checked then
     saveBtn.ImageIndex := fileM.imageIndex;
  modeAcq := TmodeAcquisition(regIni.ReadInteger('Beer','Mode',0));
  graphe.mondeX.maxi := regIni.ReadFloat('Beer','Maxi',1);
  graphe.mondeX.mini := regIni.ReadFloat('Beer','Mini',0);
  concMax := regIni.ReadFloat('Beer','ConcMax',0.1);
  graphe.mondeX.nom := regIni.ReadString('Beer','Nom','c');
  graphe.mondeX.unite := regIni.ReadString('Beer','Unite','mol/L');  
  regIni.free;
  except
  end;  
end;

procedure TBeerForm.InitAttente;
var i : integer;
begin with graphe do begin
     ClavierEdit.visible := modeAcq in [maClavier,maBeer];
     BeerCalcGrid.visible := modeAcq=maBeer;
     LabelClavier.visible := ClavierEdit.visible;
     case modeAcq of
        maIncrement : begin
          for i := 0 to Maxvecteur do
              valeurX[i] := i;
          mondeX.nom := 'n';
          mondeX.signif := 'numro';
          mondeX.unite := '';
          MondeX.Maxi := 16;
          MondeX.Mini := 0;
        end;
        maBeer : begin
           MondeX.Maxi := ConcMax;
           MondeX.Mini := 0;
        end;
        maClavier : ;
     end;
     Oscillo.Refresh;
     SetBoutonAcq;
end end; { InitAttente }

procedure TBeerForm.AcquisitionItemClick(Sender: TObject);
var oldMode : TmodeAcquisition;
begin
     oldMode := modeAcq;
     ModeBeerDlg.showModal;
     if oldMode<>modeAcq then begin
        graphe.NbrePoints := 0;
        NbreCalc := 0;
     end;
     initAttente
end;

procedure TBeerForm.OscilloPaint(Sender: TObject);
var x0,y0,x1,y1,i,j : integer;
    AbsMax : double;
begin with graphe do begin
     limiteFenetre := Oscillo.clientRect;
     if NbrePoints>0
        then begin
           AbsMax := MaxiY;
           if AbsMax<0.1 then AbsMax := 0.1;
           if (MondeY.Maxi<AbsMax) then MondeY.maxi := AbsMax;
           if modeAcq=maBeer then begin
              AbsMax := MaxiX;
              if AbsMax<ConcMax then AbsMax := ConcMax;
              if (MondeX.Maxi<AbsMax) then MondeX.maxi := AbsMax;
           end;
        end
        else begin
           MondeY.maxi := 1;
        end;
     Draw;
     BeerMesureGrid.cells[0,0] := mondeX.nom;
     BeerMesureGrid.cells[1,0] := mondeY.nom;
     BeerMesureGrid.cells[0,1] := mondeX.Unite;
     BeerMesureGrid.cells[1,1] := mondeY.Unite;
     if BeerMesureGrid.rowCount<(NbrePoints+3) then
           BeerMesureGrid.rowCount := NbrePoints+3;
     i := 0;
     while i<NbrePoints do begin
          if valeurY[i]<0
             then begin
                for j := i to (NbrePoints-2) do
                    valeurY[j] := valeurY[succ(j)];
                dec(NbrePoints);
             end
             else inc(i)
     end;
     for i := 0 to pred(NbrePoints) do begin
           BeerMesureGrid.cells[0,i+2] := FormatCourt(valeurX[i]);
           BeerMesureGrid.cells[1,i+2] := FormatCourt(valeurY[i]);
     end;
     if NbrePoints>0 then BeerMesureGrid.row := NbrePoints+1;
     for i := (NbrePoints+2) to pred(BeermesureGrid.RowCount) do begin
           BeerMesureGrid.cells[0,i] := '';
           BeerMesureGrid.cells[1,i] := '';
     end;
     if (modeAcq=maBeer) and (NbrePoints>2) then begin
        windowXY(0,0,x0,y0);
        WindowXY(mondeX.maxi,MondeX.maxi*pente,x1,y1);
        if y1<limiteFenetre.top then
           WindowXY(mondeY.maxi/pente,MondeY.maxi,x1,y1);
        Oscillo.canvas.moveTo(x0,y0);
        Oscillo.canvas.lineTo(x1,y1);
        if BeerCalcGrid.rowCount<(NbreCalc+1) then
           BeerCalcGrid.rowCount := NbreCalc+1;
        for i := 0 to pred(Nbrecalc) do begin
            BeerCalcGrid.cells[0,i] := FormatCourt(concCalc[i]);
            BeerCalcGrid.cells[1,i] := FormatCourt(absCalc[i]);
            tracePointCalc(concCalc[i],absCalc[i]);
        end;
        if NbreCalc>0 then BeerCalcGrid.row := NbreCalc;
        for i := NbreCalc to pred(BeerCalcGrid.RowCount) do begin
            BeerCalcGrid.cells[0,i] := '';
            BeerCalcGrid.cells[1,i] := '';
        end;
     end;
end end;

procedure TBeerForm.StopBtnClick(Sender: TObject);
begin
    if Graphe.NbrePoints>2
      then setBoutonAcq
      else ResetBtnClick(sender)
end;

procedure TBeerForm.EnvoieDonnees(DDE : boolean);
var i : integer;
    donnees : TstringList;
begin with graphe do begin
     Donnees := TstringList.create;
     Donnees.Add(Application.ExeName);
     Donnees.Add('Loi de Beer-Lambert '+DateTimeToStr(date+time));
     Donnees.Add(ConstanteDlg.CommEdit.text);
     Donnees.Add(MondeX.nom+crTab+MondeY.nom);
     Donnees.Add(MondeX.unite+crTab+MondeY.unite);
     for i := 0 to pred(NbrePoints) do begin
         Donnees.Add(
           FloatToStrPoint(valeurX[i])+crTab+
           FloatToStrPoint(valeurY[i]));
     end;
     if (modeAcq=maBeer) then for i := 0 to pred(NbreCalc) do begin
         Donnees.Add(
           FloatToStrPoint(concCalc[i])+crTab+
           FloatToStrPoint(absCalc[i]));
     end;
     FormDDE.AjouteConst(donnees);
     ClipBoard.astext := donnees.text;
     if DDE then if constanteDlg.newPageCB.itemIndex=1
        then FormDDE.Execute('CLIP|ADD()')
        else FormDDE.Execute('CLIP|LOAD()');
     donnees.free;   
     constanteDlg.newPageCB.itemIndex := 1;
end end;

procedure TBeerForm.SetBoutonAcq;
begin
     ResetBtn.visible := graphe.NbrePoints>2;
     SaveBtn.visible := ResetBtn.visible;
     UndoBtn.visible := graphe.NbrePoints>0;
     ClavierEdit.text := '';
     LabelClavier.caption :=
          graphe.mondeX.nom+' ('+
          graphe.mondeX.unite+') =';
     ClavierEdit.visible := modeAcq in [maClavier,maBeer];
     LabelClavier.Visible := ClavierEdit.visible;
     EnregistreBtn.visible := modeAcq=maIncrement;
     case ModeAcq of
         maClavier : begin
           ClavierEdit.setFocus;
           ClavierEdit.Hint := 'Taper la valeur de '+graphe.mondeX.nom+
                               '. Valider pour lire l''absorbance';
        end;
        maIncrement : begin
           EnregistreBtn.caption := 'Enregistrer';
           EnregistreBtn.hint := 'Cliquer pour enregistrer un point';
        end;
        maBeer : begin
           EnregistreBtn.visible := graphe.NbrePoints>2;
           ClavierEdit.setFocus;
           ClavierEdit.Hint := 'Taper la valeur de la concentration'+
                               '. Valider pour lire l''absorbance';
           EnregistreBtn.caption := 'Concentration ?';
           EnregistreBtn.hint := 'Cliquer pour dterminer une concentration inconnue';
        end;
     end;
     EnregistreBtn.enabled := EnregistreBtn.visible;
end;

procedure TBeerForm.ResetBtnClick(Sender: TObject);
begin
     graphe.NbrePoints := 0;
     NbreCalc := 0;
     initAttente;
end;

procedure TBeerForm.EnregistreEditKeyPress(Sender: TObject;
  var Key: Char);
begin
     if (key=' ') and
        (modeAcq=maIncrement) and 
        enregistreBtn.visible and
        enregistreBtn.enabled then
           enregistreBtnClick(sender);
     key := #0;
end;

procedure TBeerForm.EnregistreBtnClick(Sender: TObject);
begin with graphe do begin
      valeurCourante := SpectreMain.getAbsorbance;
      if valeurCourante=sansSignif then exit;
      case modeAcq of
          maIncrement : begin
             valeurY[NbrePoints] := valeurCourante;
             MarquePoint(NbrePoints);
             inc(NbrePoints);
             if mondeX.maxi<NbrePoints+16 then begin
                mondeX.maxi := mondeX.maxi+16;
                oscillo.refresh;
             end;
          end;
          maBeer : begin
             absCalc[NbreCalc] := valeurCourante;
             concCalc[NbreCalc] := valeurCourante/pente;
             if BeerCalcGrid.rowCount<(NbreCalc+1) then
                BeerCalcGrid.rowCount := NbreCalc+1;
             BeerCalcGrid.cells[0,NbreCalc] := FormatCourt(concCalc[NbreCalc]);
             BeerCalcGrid.cells[1,NbreCalc] := FormatCourt(valeurCourante);
             if NbreCalc>0 then BeerCalcGrid.row := NbreCalc-1;
             tracePointCalc(concCalc[NbreCalc],absCalc[NbreCalc]);
             inc(NbreCalc);
             DernierPointCalc := true;
          end;
          maClavier : ;
      end;
      setBoutonAcq;
      DejaSauve := graphe.NbrePoints<2;
end end;

procedure TBeerForm.UndoBtnClick(Sender: TObject);
begin
{ Supprimer dernier point }
     if graphe.NbrePoints>0 then
        if (modeAcq=maBeer) and dernierPointCalc
           then dec(NbreCalc)
           else dec(graphe.NbrePoints);
     Oscillo.refresh;
     EnregistreBtn.visible := (modeAcq=maIncrement) or
      ((modeAcq=maBeer) and (graphe.nbrePoints>2));
end;

procedure TBeerForm.FormResize(Sender: TObject);
begin
     Graphe.limiteCourbe := Oscillo.clientRect
end;

procedure TBeerForm.ClavierEditKeyPress(Sender: TObject;
  var Key: Char);

procedure EnregistrePointClavier;
var i,Nbre : integer;
    absTot,cTot,ecart : double;
begin with graphe do begin
      valeurX[NbrePoints] := valeurClavier;
      valeurCourante := SpectreMain.getAbsorbance;
      valeurY[NbrePoints] := valeurCourante;
      MarquePoint(NbrePoints);
      inc(NbrePoints);
      SetBoutonAcq;
      EnregistreBtn.visible := (modeAcq=maBeer) and (graphe.NbrePoints>2);
      titreEcart := '';
      if EnregistreBtn.visible then begin
         pente := 0;
         Nbre := 0;
         AbsTot := 0;
         cTot := 0;
         for i := 0 to pred(NbrePoints) do
             if (valeurX[i]>1e-9) and (valeurY[i]>1e-3) then begin
                AbsTot := absTot+valeurY[i];
                cTot := cTot+valeurX[i];
                inc(Nbre);
             end;
         if Nbre>0 then begin
             pente := absTot/cTot;
             for i := 0 to pred(NbreCalc) do
                 concCalc[i] := pente*absCalc[i];
             ecart := 0;
             Nbre := 0;
             for i := 0 to pred(Nbre) do
                   if (valeurX[i]>1e-9) and
                      (valeurY[i]>1e-3) then begin
                      ecart := ecart+sqr(valeurY[i]-pente*valeurX[i]);
                   inc(Nbre);
             end;
             ecart := sqrt(ecart/Nbre);
             TitreEcart := 'Ecart quadratique sur A : '+FormatCourt(ecart);
         end;
         oscillo.Refresh;
      end;
      ClavierEdit.text := '';
      ClavierEdit.setFocus;
      UndoBtn.visible := graphe.NbrePoints>0;
      SaveBtn.visible := graphe.NbrePoints>2;
      ResetBtn.visible :=  SaveBtn.visible;
      DernierPointCalc := false;
end end;

begin
     if key=crCR then begin
        try
        valeurClavier := StrToFloat(ClavierEdit.text);
        case modeAcq of
             maBeer : begin
                if (valeurClavier>1) or (valeurClavier<0) then begin
                    MessageDlg('Concentration suprieure  1 mol/L !',
                         mtError,[mbOK],0);
                    ClavierEdit.setFocus;
                    exit;
                 end;
                 if (valeurClavier>ConcMax) then
                    if MessageDlg(graphe.MondeX.nom+'='+
                         FloatToStrF(valeurClavier,ffFixed,3,2)+'>'+
                         FloatToStrF(ConcMax,ffFixed,3,2),
                         mtConfirmation,[mbYes,mbNo],0)=mrYes
                         then begin
                             ConcMax := valeurClavier*1.05;
                             graphe.mondeX.maxi := concMax;
                             oscillo.refresh;
                         end
                         else begin
                              ClavierEdit.setFocus;
                              exit;
                         end;
             end;
             maClavier : with graphe.mondeX do
               if (valeurClavier>maxi) or (valeurClavier<mini) then
               if (MessageDlg(FormatCourt(valeurClavier)+
                        ' ; mini='+FormatCourt(mini)+
                        ' ; maxi='+FormatCourt(maxi)+#13#10+
                        '    Vous confirmez ?',
                        mtConfirmation,[mbYes,mbNo],0)=mrNo)
                 then begin
                    ClavierEdit.setFocus;
                    exit;
                 end
                 else begin
                      if (valeurClavier>maxi) then maxi := valeurClavier;
                      if (valeurClavier<mini) then mini := valeurClavier;
                      oscillo.refresh;
                 end;
        end;{case}
        EnregistrePointClavier;
        except
              ValeurClavier := sansSignif;
              MessageDlg('Nombre mal crit',
                         mtError,[mbOK],0);
              ClavierEdit.text := '';
              ClavierEdit.setFocus;
        end;
        key := #0;
     end
end;

procedure TBeerForm.LambdaSEChange(Sender: TObject);
begin
    MajBtn.visible := true;
    Timer.enabled := true;
end;

procedure TBeerForm.TimerTimer(Sender: TObject);
begin
     if timer.interval<>1000
        then FinLambda
        else if MajBtn.imageIndex<0
           then MajBtn.imageIndex := 24
           else MajBtn.imageIndex := -1
end;

procedure TBeerForm.MajBtnClick(Sender: TObject);
begin
     Timer.enabled := false;
     Screen.cursor := crHourGlass;
     LambdaSE.enabled := false;
     SpectreMain.setLambdaLoin(lambdaSE.value);
     FinLambda;
     ClavierEdit.enabled := false;
     EnregistreBtn.enabled := false;
     ZeroBtn.enabled := false;
     MajBtn.visible := false;
     Timer.Interval := TimeOutMs;
     Timer.enabled := true;
end;

procedure TBeerForm.FinLambda;
begin
     Screen.cursor := crDefault;
     ClavierEdit.enabled := true;
     ZeroBtn.enabled := true;
     LambdaSE.enabled := true;     
     Timer.enabled := false;
     Timer.interval := 1000;
     EnregistreBtn.enabled := EnregistreBtn.visible;
end;

procedure TBeerForm.FormDestroy(Sender: TObject);
begin
     graphe.free
end;

procedure TBeerForm.FormClose(Sender: TObject; var Action: TCloseAction);
var regini : TmemIniFile;
begin
    if (graphe.NbrePoints>2) and
        not DejaSauve and
        (modeAcq<>maBeer) and
      (MessageDlg('Sauvegarde',mtConfirmation,[mbYes,mbNo],0)=idYes)
        then SaveBtnClick(sender);
    Timer.enabled := false;
    try
    RegIni := tMemIniFile.create(NomFichierIni);
    regIni.WriteBool('Save','Regressi',regressiM.Checked);
    regIni.WriteBool('Save','Clip',clipM.Checked);
    regIni.WriteBool('Save','File',fileM.Checked);
    regIni.WriteInteger('Beer','Mode',ord(modeAcq));
    regIni.WriteFloat('Beer','ConcMax',concMax);
    regIni.WriteFloat('Beer','Maxi',graphe.mondeX.maxi);
    regIni.WriteFloat('Beer','Mini',graphe.mondeX.mini);
    regIni.WriteString('Beer','Nom',graphe.mondeX.nom);
    regIni.WriteString('Beer','Unite',graphe.mondeX.unite);        
    regIni.UpdateFile;
    RegIni.Free;
    except
    end;
    SpectreMain.setMode(mNone);
end;

procedure TBeerForm.FormActivate(Sender: TObject);
begin
     SpectreMain.setMode(mBeer);
     InitAttente
end;

procedure TBeerForm.MarquePoint(i : indiceVecteur);
begin
     graphe.tracePointCinet(i);
     if BeerMesureGrid.rowCount<(i+3) then
         BeerMesureGrid.rowCount := i+3;
     BeerMesureGrid.cells[0,i+2] := FormatCourt(graphe.valeurX[i]);
     BeerMesureGrid.cells[1,i+2] := FormatCourt(graphe.valeurY[i]);
     BeerMesureGrid.row := i+2;
end;

procedure TBeerForm.ZeroBtnClick(Sender: TObject);
var sauveMaj : boolean;
begin
    EnregistreBtn.enabled := false;
    Timer.enabled := false;
    sauveMaj :=MajBtn.enabled;
    MajBtn.enabled := false;
    Application.processMessages;
    SpectreMain.setZeroProc;
    EnregistreBtn.enabled := EnregistreBtn.visible;
    MajBtn.enabled := sauveMaj;
end;

procedure TBeerForm.PrintBtnClick(Sender: TObject);
begin
     graphe.imprime
end;

procedure TBeerForm.BeerMesureGridSelectCell(Sender: TObject; ACol,
  ARow: Integer; var CanSelect: Boolean);
begin
    CanSelect := Acol=0
end;

procedure TBeerForm.BeerMesureGridKeyPress(Sender: TObject; var Key: Char);
const
      CharGetFloat : TcharSet = ['0'..'9','+','-','e','E','.',',',crSupprArr,crTab,crCR];
begin
     if key in [',','.']
        then key := decimalSeparator
        else if not ( key in CharGetFloat ) then key := #0
end;

procedure TBeerForm.BeerMesureGridSetEditText(Sender: TObject; ACol,
  ARow: Integer; const Value: String);
begin
    if (Acol=0) and (arow>=2) then with graphe do begin
        try
        valeurX[arow-2] := StrToFloat(value);
        if (valeurX[arow-2]>mondeX.maxi) then begin
              mondeX.maxi := valeurX[arow-2]*1.05;
              oscillo.refresh;
        end;
        except
        end;
    end;
end;

procedure TBeerForm.FormKeyPress(Sender: TObject; var Key: Char);
begin
     if (key=' ') and
        (modeAcq=maIncrement) and
        enregistreBtn.visible and
        enregistreBtn.enabled then begin
           enregistreBtnClick(sender);
           key := #0;
     end;
end;

procedure TBeerForm.SaveBtnClick(Sender: TObject);
begin
    if regressiM.Checked then if ConstanteDlg.showModal=mrOk then begin
        DejaSauve := true;
        EnvoieDonnees(true);
        constanteDlg.newPageCB.itemIndex := 1;
    end;
    if clipM.Checked then begin
       DejaSauve := true;
       EnvoieDonnees(false);
    end;
    if fileM.Checked then SaveItem;
end;

procedure TBeerForm.RegressiMClick(Sender: TObject);
begin
  saveBtn.ImageIndex := (sender as TmenuItem).imageIndex;
  (sender as TmenuItem).checked := true;
  SaveBtnClick(Sender);
end;

end.


