unit JenwayCinet;

interface

uses Windows, Classes, Graphics, Forms, Controls, Menus,
  Dialogs, StdCtrls, Buttons, ExtCtrls, sysUtils, Messages,  clipBrd, spin,
  ADport, ADexcept, oomisc, inifiles,
  graphker, jmmUtil, cfgSpect, SpecMain, ComCtrls, ToolWin;

type
  TEtatAcquisition = (eaReglageLambda,eaReglageZero,eaEnCours,eaTerminee,eaAttente);

  TCinetiqueForm = class(TForm)
    SaveDialog: TSaveDialog;
    Timer: TTimer;
    Oscillo: TPaintBox;
    BoutonsPanel: TPanel;
    DeltatSB: TSpinButton;
    LabelDeltat: TLabel;
    PanelDuree: TPanel;
    ZeroBtn: TBitBtn;
    LambdaBtn: TBitBtn;
    Label2: TLabel;
    LambdaSE: TSpinEdit;
    StartBtn: TBitBtn;
    EditBidon: TEdit;
    PanelAbs: TPanel;
    LectureS: TShape;
    ToolBar1: TToolBar;
    SaveBtn: TToolButton;
    RepereBtn: TToolButton;
    ResetBtn: TToolButton;
    StopBtn: TToolButton;
    ZeroBtnBis: TToolButton;
    ExitBtn: TToolButton;
    PrintBtn: TToolButton;
    SavePopupMenu: TPopupMenu;
    RegressiM: TMenuItem;
    ClipM: TMenuItem;
    FileM: TMenuItem;
    DureeEdit: TEdit;
    DureeSpin: TSpinButton;
    Label1: TLabel;
    procedure ExitItemClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
    procedure InitAttente;
    procedure StartBtnClick(Sender: TObject);
    procedure OscilloPaint(Sender: TObject);
    procedure StopBtnClick(Sender: TObject);
    procedure ResetBtnClick(Sender: TObject);
    procedure RepereBtnClick(Sender: TObject);
    procedure FilePageItemClick(Sender: TObject);
    procedure RegPageBtnClick(Sender: TObject);
    procedure EnregistreBtnClick(Sender: TObject);
    procedure DeltatSBDownClick(Sender: TObject);
    procedure DeltatSBUpClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ZeroBtnClick(Sender: TObject);
    procedure LambdaBtnClick(Sender: TObject);
    procedure ExitBtnClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure LambdaSEChange(Sender: TObject);
    procedure EditBidonKeyPress(Sender: TObject; var Key: Char);
    procedure ZeroBtnBisClick(Sender: TObject);
    procedure PrintBtnClick(Sender: TObject);
    procedure RegressiMClick(Sender: TObject);
    procedure SaveBtnClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure DureeEditExit(Sender: TObject);
    procedure DureeEditKeyPress(Sender: TObject; var Key: Char);
    procedure DureeSpinDownClick(Sender: TObject);
    procedure DureeSpinUpClick(Sender: TObject);
  private
    nomFichierIni : string;
    NbreMax : integer;
    DureeMesure,DeltatMesure : word; { en s }
    EtatAcq  : TetatAcquisition;
    InstantDebut  : TdateTime;
    NomFichierData : string;
    DejaSauve,FormatRW3 : boolean;
    ValeurCourante : double;
    fichier : textFile;
    procedure EcritPageRW3;
    Procedure EcritPageTableur;
    procedure EnregistrePoint;
    Procedure setBoutons(etat : TEtatAcquisition);
    procedure ChangeNbre;
  public
      Graphe : Tgraphe;
  protected
      procedure WMGetMinMaxInfo(var Msg: TWMGetMinMaxInfo); message wm_GetMinMaxInfo;
  end;

var
  CinetiqueForm: TCinetiqueForm;

implementation

uses SpectDDE,JenwayConst;

const minPoints = 8;
      deltatMin = 2; { soit 30 secondes }
      timeOutms = 2000; // soit 2 s
      dureeMax = 3600*4; // 4 heures

{$R *.DFM}

procedure TCinetiqueForm.ExitItemClick(Sender: TObject);
begin
    SpectreMain.setMode(mNone);
    Close
end;

Procedure TCinetiqueForm.EcritPageRW3;
var j : indiceVecteur;
    i : integer;
    repere : Trepere;
begin with graphe do begin
    writeln(fichier,symbReg,1,' PAGE COMMENT');
    if constanteDlg.CommEdit.text<>''
       then writeln(fichier,constanteDlg.CommEdit.text)
       else writeln(fichier,'Suivi de cintique par spectro Jenway 6300 '+DateTimeToStr(date+time));
    writeln(fichier,symbReg2,NbrePoints,' VALEUR VAR');
    for j := 0 to pred(NbrePoints) do begin
        write(fichier,FloatToStrF(valeurX[j],ffGeneral,PrecisionTemps,2));
        write(fichier,' ',FloatToStrF(valeurY[j],ffGeneral,PrecisionAbs,2));
        writeln(fichier);
    end; { for j }
    if constanteDlg.AvecConstante then begin
    	  writeln(fichier,symbReg2,'1 VALEUR CONST');
       	writeln(fichier,constanteDlg.ValeurConstEdit.text);
    end;
    if ListeRepere.count>0 then begin
         writeln(fichier,symbReg2,ListeRepere.count,' REPERE');
         for i := 0 to pred(ListeRepere.count) do begin
             repere := Trepere(listeRepere[i]);
             writeln(fichier,FloatToStrF(repere.valeur,ffGeneral,PrecisionTemps,2),crTab,repere.text);
         end;
    end;
end end; {ecritPageRW3}

Procedure TCinetiqueForm.EcritPageTableur;
var j : indiceVecteur;
    i : integer;
    repere : Trepere;
begin with graphe do begin
    for j := 0 to pred(NbrePoints) do begin
      	write(fichier,FloatToStrPoint(valeurX[j]));
      	write(fichier,crTab,FloatToStrPoint(valeurY[j]));
  	    writeln(fichier);
    end;
    if ListeRepere.count>0 then begin
       writeln(fichier);
       writeln(fichier,'REPERE');
       for i := 0 to pred(ListeRepere.count) do begin
          repere := Trepere(listeRepere[i]);
          write(fichier,FloatToStrPoint(repere.valeur),crTab,repere.text);
          writeln(fichier);
       end; { for j }
    end;
    with constanteDlg do if AvecConstante then begin
        writeln(fichier,symbReg2,'1 VALEUR CONST');
        writeln(fichier,ValeurConstEdit.text);
    end;
end end; {ecritPageTableur}

procedure TCinetiqueForm.FormCreate(Sender: TObject);
var regini : TmemIniFile;
begin
  nomFichierIni := changeFileExt(application.exeName,'.ini');
  Graphe := Tgraphe.Create;
  Graphe.etatSpectre := esAbsorbance;
  graphe.NbreCourbe := 1;
  graphe.trace := tCinet;
  Graphe.Canvas := Oscillo.Canvas;
  DeltatMesure := deltatMin;
  DejaSauve := false;
  InstantDebut := time;
  DureeMesure := 120;
  DureeEdit.Text := TimeToStr(EncodeDuree(DureeMesure));
  LabelDeltat.caption := delta+'t='+IntToStr(deltatMesure)+' s';
  with graphe do begin
     mondeX.nom := 't';mondeY.nom := 'A';
     mondeX.signif := 'temps';mondeY.signif := 'Absorbance';
     mondeX.unite := 's';mondeY.unite := '';
     MondeX.Mini := 0;mondeY.mini := 0;
     MondeX.Maxi := dureeMesure;mondeY.maxi := Spectro.maxiAbs;
  end;
  LambdaSE.minValue := Spectro.miniLambda;
  LambdaSE.maxValue := Spectro.maxiLambda;
  LambdaSE.value := 500;
  try
  RegIni := tMemIniFile.create(NomFichierIni);
  regressiM.Checked := regIni.ReadBool('Save','Regressi',true);
  if regressiM.Checked then
     saveBtn.ImageIndex := regressiM.imageIndex;
  clipM.Checked := regIni.ReadBool('Save','Clip',false);
  if clipM.Checked then
     saveBtn.ImageIndex := clipM.imageIndex;
  fileM.Checked := regIni.ReadBool('Save','File',false);
  if fileM.Checked then
     saveBtn.ImageIndex := fileM.imageIndex;
  LambdaSE.value := regIni.ReadInteger('Cinetique','Lambda',600);
  DeltatMesure := regIni.ReadInteger('Cinetique','Deltat',deltatMin);
  DureeMesure := regIni.ReadInteger('Cinetique','Duree',120);
  regIni.free;
  NbreMax := DureeMesure div DeltatMesure;
  DureeEdit.Text := TimeToStr(EncodeDuree(DureeMesure));
  LabelDeltat.caption := delta+'t='+IntToStr(deltatMesure)+' s';  
  except
  end;   
  setBoutons(eaReglageLambda);
end;

procedure TCinetiqueForm.TimerTimer(Sender: TObject);
begin
   lectureS.visible := true;
   Application.processMessages;
   valeurCourante := SpectreMain.getAbsorbance;
   if valeurCourante<>sansSignif then EnregistrePoint;
   lectureS.visible := false;
end;

procedure TCinetiqueForm.InitAttente;
var i : integer;
begin with graphe do begin
     timer.enabled := false;
     DureeEdit.Text := TimeToStr(EncodeDuree(DureeMesure));
     LabelDeltat.caption := IntToStr(deltatMesure)+' s';
     Reset;
     MondeX.Maxi := dureeMesure;
     MondeY.maxi := Spectro.maxiAbs;
     for i := 0 to MaxVecteur do
         valeurX[i] := i*deltatMesure;
     PanelDuree.Caption := '';
     PanelAbs.Caption := '';     
     Oscillo.Refresh;
     SetBoutons(eaAttente);
end end; { InitAttente }

procedure TCinetiqueForm.StartBtnClick(Sender: TObject);
begin
     if (EtatAcq=eaTerminee) and
        not DejaSauve and
        (MessageDlg('Sauvegarde',mtConfirmation,[mbYes,mbNo],0)=idYes)
        then SaveBtnClick(sender);
     InstantDebut := time;
     DejaSauve := false;
     graphe.NbrePoints := 0;
     SetBoutons(eaEnCours);
     TimerTimer(nil); { valeur Initiale }
end;

procedure TCinetiqueForm.OscilloPaint(Sender: TObject);
begin
     graphe.limiteFenetre := Oscillo.clientRect;
     graphe.Draw;
end;

procedure TCinetiqueForm.StopBtnClick(Sender: TObject);
begin
    if (Graphe.NbrePoints>minPoints) or
       (Graphe.NbrePoints>NbreMax div 2)
      then setBoutons(eaTerminee)
      else ResetBtnClick(sender)
end;

procedure TCinetiqueForm.SetBoutons(etat : TetatAcquisition);
var mini,maxi : double;
begin
     EtatAcq := etat;
     StartBtn.visible := Etat=eaAttente;
     ResetBtn.visible := Etat=eaTerminee;
     StopBtn.visible := Etat=eaEnCours;
     ExitBtn.Visible := Etat<>eaEnCours;
     RepereBtn.enabled := Etat=eaEnCours;
     LambdaBtn.visible := Etat=eaReglageLambda;
     ZeroBtn.visible := Etat=eaReglageZero;
     ZeroBtnBis.visible := Etat<>eaReglageZero;
     LambdaSE.enabled := not (EtatAcq in [eaEnCours,eaTerminee]);

     SaveBtn.visible := Etat=eaTerminee;
     PanelDuree.visible := Etat=eaEnCours;
     PanelAbs.visible := Etat=eaEnCours;

     if Etat=eaEnCours
        then timer.Interval := DeltatMesure*1000
        else timer.Interval := TimeOutMs;
     Timer.Enabled := Etat=eaEnCours;
     if Etat=eaTerminee then begin
        if graphe.NbrePoints>2
           then GetMinMax(graphe.valeurY,graphe.NbrePoints,mini,maxi)
           else maxi := Spectro.maxiAbs;
        if maxi<1 then maxi := 1;
        graphe.SetMonde(0,0,dureeMesure,maxi);
        Oscillo.refresh;
     end;
end;

procedure TCinetiqueForm.ResetBtnClick(Sender: TObject);
begin with graphe do begin
     NbrePoints := 0;
     ListeRepere.clear;
     Oscillo.refresh;
     setBoutons(eaAttente);
     PanelDuree.Caption := '';
     PanelAbs.Caption := '';     
end end;

procedure TCinetiqueForm.RepereBtnClick(Sender: TObject);
var texte : shortString;
    InstantClick : double;
begin
     instantClick := DureeEcoulee(instantDebut);
     texte := InputBox('Cration d''un repre', 'Signification', '');
     graphe.AjouteRepere(instantClick,texte);
end;

procedure TCinetiqueForm.EnregistrePoint;
begin with graphe do begin
      valeurX[NbrePoints] := DureeEcoulee(instantDebut);
      panelDuree.Caption := TimeToStr(time-instantDebut);
      panelAbs.Caption := floatToStrF(valeurCourante,ffFixed,4,3);
      valeurY[NbrePoints] := valeurCourante;
      tracePointCinet(NbrePoints);
      inc(NbrePoints);
      if DureeEcoulee(instantDebut)>dureeMesure then 
           SetBoutons(eaTerminee);
end end;

procedure TCinetiqueForm.FilePageItemClick(Sender: TObject);
begin
    AssignFile(fichier,NomFichierData);
    Append(fichier);
    if formatRW3
       then ecritPageRW3
       else ecritPageTableur;
    CloseFile(fichier);
end;

procedure TCinetiqueForm.RegPageBtnClick(Sender: TObject);
begin
    if ConstanteDlg.showModal=mrOk then begin
        FormDDE.EnvoieDonneesCinetique(true);
        constanteDlg.newPageCB.itemIndex := 1;
    end;
end;

procedure TCinetiqueForm.EnregistreBtnClick(Sender: TObject);
begin
    EnregistrePoint;
    SaveBtn.visible := graphe.NbrePoints>3;
end;

procedure TCinetiqueForm.DeltatSBUpClick(Sender: TObject);
begin
     inc(DeltatMesure);
     ChangeNbre;
end;

procedure TCinetiqueForm.DeltatSBDownClick(Sender: TObject);
begin
     if DeltatMesure>deltatMin then begin
           dec(deltatMesure);
           ChangeNbre;
     end;
end;

procedure TCinetiqueForm.FormClose(Sender: TObject;var Action: TCloseAction);
var regini : TmemIniFile;
begin
    if EtatAcq=eaEncours then stopBtnClick(sender);
    if (EtatAcq=eaTerminee) and
        not DejaSauve and
      (MessageDlg('Sauvegarde',mtConfirmation,[mbYes,mbNo],0)=idYes)
        then SaveBtnClick(sender);
    try
    RegIni := tMemIniFile.create(NomFichierIni);
    regIni.WriteBool('Save','Regressi',regressiM.Checked);
    regIni.WriteBool('Save','Clip',clipM.Checked);
    regIni.WriteBool('Save','File',fileM.Checked);
    regIni.WriteInteger('Cinetique','Lambda',LambdaSE.value);
    regIni.WriteInteger('Cinetique','Nombre',NbreMax);
    regIni.WriteInteger('Cinetique','Deltat',DeltatMesure);
    regIni.UpdateFile;
    RegIni.Free;
    except
    end;
    Timer.enabled := false;
    SpectreMain.setMode(mNone);
end;

procedure TCinetiqueForm.ZeroBtnClick(Sender: TObject);
begin
     spectreMain.setZeroProc;
     initAttente;
end;

procedure TCinetiqueForm.LambdaBtnClick(Sender: TObject);
begin with SpectreMain do begin
     ZeroBtn.visible := false;
     LambdaBtn.visible := false;
     StartBtn.visible := false;
     Screen.cursor := crHourGlass;
     setLambdaLoin(lambdaSE.value);
     Screen.cursor := crDefault;
     setBoutons(eaReglageZero);
end end;

procedure TCinetiqueForm.WMGetMinMaxInfo(var Msg: TWMGetMinMaxInfo);
begin
     with Msg.MinMaxInfo^ do begin
          ptMinTrackSize := point(550,120);
          ptMaxTrackSize := point(screen.width-20,screen.height-20);
     end;
end;

procedure TCinetiqueForm.ExitBtnClick(Sender: TObject);
begin
     close
end;

procedure TCinetiqueForm.FormDestroy(Sender: TObject);
begin
    Graphe.free
end;

procedure TCinetiqueForm.LambdaSEChange(Sender: TObject);
begin
     setBoutons(eaReglageLambda)
end;

procedure TCinetiqueForm.ChangeNbre;
begin
     NbreMax := DureeMesure div DeltatMesure;
     if NbreMax>MaxVecteur then NbreMax := MaxVecteur;
     if NbreMax<minPoints then begin
        NbreMax := minPoints;
        DureeMesure := NbreMax*deltatMesure;
     end;
     if NbreMax>=300 then NbreMax := 60*(NbreMax div 60);
     if NbreMax>=90 then NbreMax := 30*(NbreMax div 30);
     if NbreMax>=30 then NbreMax := 10*(NbreMax div 10);
     DureeEdit.Text := TimeToStr(EncodeDuree(DureeMesure));
     LabelDeltat.caption := IntToStr(deltatMesure)+' s';
     graphe.MondeX.Maxi := dureeMesure;
     if EtatAcq=eaEnCours then
        timer.Interval := DeltatMesure*1000;
     Oscillo.refresh;
end;


procedure TCinetiqueForm.EditBidonKeyPress(Sender: TObject; var Key: Char);
begin
     if key=' ' then begin
        if StartBtn.visible then startBtnClick(sender);
        if ZeroBtn.visible then zeroBtnClick(sender);
        if LambdaBtn.visible then lambdaBtnClick(sender);
     end;
     key := #0;
end;

procedure TCinetiqueForm.ZeroBtnBisClick(Sender: TObject);
begin
    SpectreMain.setZeroProc
end;

procedure TCinetiqueForm.PrintBtnClick(Sender: TObject);
begin
    Graphe.imprime
end;

procedure TCinetiqueForm.RegressiMClick(Sender: TObject);
begin
  saveBtn.ImageIndex := (sender as TmenuItem).imageIndex;
  (sender as TmenuItem).checked := true;
  SaveBtnClick(Sender);
end;

procedure TCinetiqueForm.SaveBtnClick(Sender: TObject);

procedure SaveItem;

Procedure ecritEnTeteTableur;
begin with graphe do begin
   writeln(fichier,'Cintique avec Jenway 6300');
   writeln(fichier,'t'+crTab+'A');
   writeln(fichier,'s'+crTab+'');
end end; { ecritEnTeteTableur }

Procedure ecritEnTeteRW3;
begin with graphe,constanteDlg do begin
   writeln(fichier,'EVARISTE REGRESSI WINDOWS 1.0');
   writeln(fichier,symbReg,'2 NOM VAR');
   writeln(fichier,'t');
   writeln(fichier,'A');
   writeln(fichier,symbReg,'2 UNITE VAR');
   writeln(fichier,'s');
   writeln(fichier,'');
   writeln(fichier,symbReg,'2 SIGNIF VAR');
   writeln(fichier,'dure');
   writeln(fichier,'Absorbance');
   if AvecConstante then begin
      writeln(fichier,symbReg,'1 NOM CONST');
      writeln(fichier,NomConstEdit.text);
      writeln(fichier,symbReg,'1 UNITE CONST');
      writeln(fichier,UniteConstEdit.text);
      writeln(fichier,symbReg,'1 SIGNIF CONST');
      writeln(fichier,SignifConstEdit.text);
   end;
   writeln(fichier,symbReg,'1 ACQUISITION');
   writeln(fichier,Application.ExeName)
end end; { ecritEnTeteRW3 }

begin
     SaveDialog.filter := 'Regressi (*.rw3)|*.rw3|Tableur ASCII (*.txt)|*.txt';
     SaveDialog.defaultExt := 'RW3';
     if SaveDialog.Execute then begin
         FormatRW3 := AnsiUpperCase(ExtractFileExt(saveDialog.FileName))='.RW3';
         NomFichierData := saveDialog.FileName;
         try
         AssignFile(fichier,saveDialog.FileName);
         Rewrite(fichier);
         DejaSauve := true;
         if formatRW3
            then begin
               ecritEnTeteRW3;
               ecritPageRW3;
            end
            else begin
               ecritEnTeteTableur;
               ecritPageTableur;
            end;
         CloseFile(fichier);
         except
          showMessage('Erreur d''criture du fichier');
         end;
     end;
end;

begin
    if regressiM.Checked then if ConstanteDlg.showModal=mrOk then begin
        DejaSauve := true;
        FormDDE.EnvoieDonneesCinetique(true);
        constanteDlg.newPageCB.itemIndex := 1;
    end;
    if clipM.Checked then begin
       DejaSauve := true;
       FormDDE.EnvoieDonneesCinetique(false)
    end;
    if fileM.Checked then SaveItem;
end;

procedure TCinetiqueForm.FormActivate(Sender: TObject);
begin
    SpectreMain.setMode(mCinetique)
end;

procedure TCinetiqueForm.DureeEditExit(Sender: TObject);
var newMaxi : integer;
begin
    try
    newMaxi := dateTimeToFloat(dureeEdit.text);
    if newMaxi<>DureeMesure then begin
        DureeMesure := newMaxi;
        ChangeNbre;
    end;
    except
    DureeEdit.text := TimeToStr(EncodeDuree(DureeMesure));
    end;
end;

procedure TCinetiqueForm.DureeEditKeyPress(Sender: TObject; var Key: Char);
begin
     case key of
        crCR : begin
           try
           DureeMesure := dateTimeToFloat(dureeEdit.text);
           except
           DureeEdit.text := TimeToStr(EncodeDuree(DureeMesure));
           end;
        end;
        '.',',' : key := decimalSeparator;
        '0'..'9','m','','s',' ','i','n' : ;
        crDroite,crGauche,crSuppr,crSupprArr : ;
        else key := #0
     end;
end;

procedure TCinetiqueForm.DureeSpinDownClick(Sender: TObject);
begin
     DureeMesure := duree125(DureeMesure/2.15);
     if dureeMesure<30 then dureeMesure := 30;
     ChangeNbre;
end;

procedure TCinetiqueForm.DureeSpinUpClick(Sender: TObject);
var k : integer;
begin
     DureeMesure := duree125(2.15*DureeMesure);
     if etatAcq=eaEnCours then with graphe do
        if NbrePoints>(MaxVecteur div 2) then begin
             { supprimer un point sur 2 }
           NbrePoints := NbrePoints div 2;
           for k := 1 to pred(NbrePoints) do begin
                  valeurX[k] := valeurX[2*k];
                  valeurY[k] := valeurY[2*k];
           end;
     end;
     ChangeNbre;
end;

end.



