unit JenwayConst;

interface

uses WinTypes, WinProcs, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, SysUtils, dialogs, jmmutil, cfgSpect;

type
  TConstanteDlg = class(TForm)
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    NewPageCB: TRadioGroup;
    GroupBox2: TGroupBox;
    UniteL1: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    NomConstEdit: TEdit;
    UniteConstEdit: TEdit;
    ValeurConstEdit: TEdit;
    CommEdit: TEdit;
    Label3: TLabel;
    Label4: TLabel;
    SignifConstEdit: TEdit;
    procedure FormActivate(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
  public
    modeRegressi : TmodeRegressi;
    AddColPermis : boolean;
    avecConstante : boolean;
    valeurConst : double;
  end;

var
  ConstanteDlg: TConstanteDlg;

implementation

{$R *.DFM}

procedure TConstanteDlg.FormActivate(Sender: TObject);
begin
     AddColPermis := AddColPermis and
         (modeRegressi in [rFichier,rColonne]);
     case modeRegressi of
          rFichier : begin
            if AddColPermis and (NewPageCB.items.count=2) then
               NewPageCB.Items.add('Nouvelle &colonne');
            if not AddColPermis and (NewPageCB.items.count=3) then
               NewPageCB.Items.delete(2);
            NewPageCB.Items[1] := 'Nouvelle &page';
          end;
          rColonne : begin
               if NewPageCB.items.count=3 then
                  NewPageCB.Items.delete(2);
               NewPageCB.Items[1] := 'Nouvelle &colonne';
          end;
          rPage : begin
               if NewPageCB.items.count=3 then
                  NewPageCB.Items.delete(2);
               NewPageCB.Items[1] := 'Nouvelle &page';
          end;
     end;
end;

procedure TConstanteDlg.OKBtnClick(Sender: TObject);
begin
     case NewPageCB.itemIndex of
          0 : ModeRegressi := rFichier;
          1 : if modeRegressi=rFichier then
                 modeRegressi := rPage;
          2 : ModeRegressi := rColonne;
      end;
      try
          ValeurConst := StrToFloat(constanteDlg.ValeurConstEdit.text);
          AvecConstante := constanteDlg.NomConstEdit.text<>'';
      except
          avecConstante := false;
          ValeurConst := 0;
      end;
end;

procedure TConstanteDlg.FormCreate(Sender: TObject);
begin
     ModeRegressi := rFichier;
end;

end.
