unit ModeBeer;

interface

uses Windows, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, Spin, ExtCtrls, sysutils,
  graphker, jmmUtil, JenwayBeer, ComCtrls;

type
  TModeBeerDlg = class(TForm)
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    HelpBtn: TBitBtn;
    Bevel1: TBevel;
    ModeAcqRG: TRadioGroup;
    NoteBook: TPageControl;
    Label10: TLabel;
    Memo1: TMemo;
    Memo2: TMemo;
    GrandeurGB: TGroupBox;
    Label4: TLabel;
    Label5: TLabel;
    LabelMin: TLabel;
    LabelMax: TLabel;
    EditNom: TEdit;
    EditUnite: TEdit;
    EditMin: TEdit;
    EditMax: TEdit;
    EditMaxBeer: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    EditSignif: TEdit;
    ClavierTS : TTabSheet;
    BeerTS : TTabSheet;
    BarreTS : TTabSheet;
    procedure OKBtnClick(Sender: TObject);
    procedure ModeAcqRGClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
  public
  end;

var
  ModeBeerDlg: TModeBeerDlg;

implementation

{$R *.DFM}

procedure TModeBeerDlg.OKBtnClick(Sender: TObject);
begin with BeerForm do begin
        ModeAcq := TmodeAcquisition(ModeAcqRG.itemIndex);
        if modeAcq=maClavier then with graphe.mondeX do begin
           Nom := EditNom.text;
           Unite := EditUnite.text;
           Signif := EditSignif.text;
           try
           Mini := strToFloat(EditMin.text);
           except
              Mini := 0;
           end;
           try
           Maxi := strToFloat(EditMax.text);
           except
              Maxi := 5;
           end;
           VerifMinMaxReal(mini,maxi);
        end;
        if modeAcq=maBeer then with graphe.mondeX do begin
           try
           ConcMax := strToFloat(EditMax.text);
           ConcMax := abs(ConcMax);
           except
              ConcMax := 0.1;
           end;
           if concMax>1 then concMax := 1;
           Maxi := ConcMax;
           Mini := 0;
           Nom := 'c';
           Unite := 'mol/L';
           Signif := 'Concentration';
        end;
end end;

procedure TModeBeerDlg.ModeAcqRGClick(Sender: TObject);
begin
    NoteBook.ActivePageIndex := ModeAcqRG.itemIndex;
end;

procedure TModeBeerDlg.FormActivate(Sender: TObject);
begin with BeerForm do begin
     with graphe.mondeX do begin
       if nom='n'
          then begin
             EditNom.text := 'c';
             EditUnite.text := 'mol/L';
             EditSignif.text := 'Concentration';
             EditMax.text := FloatToStr(ConcMax);
          end
          else begin
             EditNom.text := nom;
             EditUnite.text := Unite;
             EditSignif.text := Signif;
             EditMax.text := FloatToStr(maxi);
          end;
       EditMin.text := FloatToStr(mini);
       EditMaxBeer.text := FloatToStr(maxi);
     end;
     ModeAcqRG.itemIndex := ord(modeAcq);
end end;

end.
