unit Specmain;

interface

uses Windows, Types, Classes, Graphics, Forms, Controls, Menus,
  Dialogs, StdCtrls, Buttons, ExtCtrls, ADport, sysUtils, Messages,
  clipBrd, adexcept, oomisc, registry, spin,
  cfgSpect, graphker, jmmUtil, Tabs, Grids, ComCtrls, ImgList, ToolWin,
  ActnMan, ActnCtrls, StdActns, ActnList, StdStyleActnCtrls, CustomizeDlg,
  XPMan;

type
  Tcurseur = (curNormal,curDebut,curFin);
  tLedGBF = (lGray,lRed,lGreen);  
  Tmode = (mNone,mSpectre,mCinetique,mBeer);

  TSpectreMain = class(TForm)
    VoieSerie: TApdComPort;
    PaintBox: TPaintBox;
    PanelBoutons: TPanel;
    StatusBar: TStatusBar;
    Label1: TLabel;
    DebutSE: TSpinEdit;
    Label2: TLabel;
    FinSE: TSpinEdit;
    PanelAbs: TPanel;
    PanelLambda: TPanel;
    PanelBlocage: TPanel;
    ActionManager1: TActionManager;
    BlancAction: TAction;
    FileExit1: TFileExit;
    SpectreAction: TAction;
    RegSaveAction: TAction;
    ConfigComAction: TAction;
    ActionToolBar1: TActionToolBar;
    ImageList1: TImageList;
    PasLabel: TLabel;
    PasLambdaSE: TSpinEdit;
    StopAction: TAction;
    Label3: TLabel;
    XPManifest1: TXPManifest;
    BeerAction: TAction;
    CinetAction: TAction;
    HelpContents1: THelpContents;
    Action1: TAction;
    FileOpen: TFileOpen;
    FileSaveAs: TFileSaveAs;
    ProgressBar1: TProgressBar;
    ConnectBtn: TBitBtn;
    connectMemo: TMemo;
    SatureBtn: TSpeedButton;
    procedure ShowHint(Sender: TObject);
    procedure ExitItemClick(Sender: TObject);
    procedure SauveSpectreClick(Sender: TObject);
    procedure AboutItemClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure InitAppareil;
    procedure PaintBoxPaint(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure RegressiItemClick(Sender: TObject);
    procedure RegSaveBtnClick(Sender: TObject);
    procedure BlancActionExecute(Sender: TObject);
    procedure SpectreBtnClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure VoieSerieTriggerAvail(CP: TObject; Count: Word);
    procedure VoieSerieTriggerData(CP: TObject; TriggerHandle: Word);
    procedure BornesChange(Sender: TObject);
    procedure PaintBoxMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure PasLambdaSEChange(Sender: TObject);
    procedure ConfigComActionExecute(Sender: TObject);
    procedure PaintBoxMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PaintBoxMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure StopActionExecute(Sender: TObject);
    procedure FileOpenAccept(Sender: TObject);
    procedure CinetActionExecute(Sender: TObject);
    procedure BeerActionExecute(Sender: TObject);
    procedure ClipMClick(Sender: TObject);
    procedure Quitter1Click(Sender: TObject);
    procedure ConnectBtnClick(Sender: TObject);
  private
    chaineLue : shortString;
    oldFin,oldDebut,oldPas,debutEffectif : integer;
    SauvegardeAfaire,dataOK : boolean;
    Hcommande,Hgoto : integer;
    curseur : Tcurseur;
    debutPB,finPB : longInt;
    AcquisitionEnCours : Tmode;
    LambdaEnCours,gotoEnCours : boolean;
    Procedure setBoutonAcq;
    procedure InterpoleSpectre;
    procedure InterpoleBlanc;    
    Procedure TraceDebutFin;
    Procedure TraceUV;
    Procedure affecteDebutFin;
    procedure AppMessage(var Msg: TMsg; var Handled: Boolean);
  public
      Procedure demandeAbsLambda;
      procedure SetZeroProc;
      function getAbsorbance : double;
      procedure SetLambdaProche(lambda : integer);
      procedure SetLambdaLoin(lambda : integer);
      Procedure SetMode(Acq : Tmode);
  protected
  end;

var
  SpectreMain: TSpectreMain;

implementation

uses About, choixSpe, spectDDE, JenwayConst, JenwayCinet, JenwayBeer;

{$R *.DFM}

const margeLambda = 30;
      TitreBlanc = 'Blanc en cours';
      TitreZero = 'Zro  la longueur d''onde maxi';

procedure TspectreMain.AppMessage(var Msg: TMsg; var Handled: Boolean);

function NonCouperCopier : boolean;
var EditCtrl : TcustomEdit;
begin
   NonCouperCopier := true;
   if ( (msg.Wparam=24) or (msg.Wparam=3) ) and
      (Screen.ActiveControl is TCustomEdit)
      then begin
          EditCtrl := Screen.ActiveControl as TCustomEdit;
          if EditCtrl.SelLength > 0 then begin
             case msg.Wparam of
                 24 : EditCtrl.CutToClipBoard;
                 3 :  EditCtrl.CopyToClipBoard;
             end;
             Handled := true;
             NonCouperCopier := false;
          end;
   end;
end;

const
         GrecMaj : array[1..26] of char =
  ('A','B','C',deltaMaj,'E',phiMaj,gammaMaj,'H','I',psiMaj,'K',lambdaMaj,
   'M','N',videMaj,piMaj,thetaMaj,'R',sigmaMaj,'T','U','V',omegaMaj,xiMaj,'Y','Z');

        GrecMin : array[1..26] of char =
  (alpha,beta,chi,delta,epsilon,phi,gamma,eta,'i',psi,'k',LettreLambda,
   mu,nu,vide,piMin,theta,rho,sigma,tau,'u','v',omega,xi,'y',zeta);

begin with Msg do
     if Message=wm_char then begin
            if (Wparam>0) and (Wparam<=26) then
             if (GetKeyState(vk_control)<0) then
                 if (GetKeyState(vk_shift)<0) or
                    (GetKeyState(vk_capital)<0)
                    then Wparam := ord(GrecMaj[Wparam])
                    else if (Wparam<>22) and NonCouperCopier
                      { Edition Windows copier coller couper }
                         then Wparam := ord(GrecMin[Wparam]);
    end;
end;

procedure TSpectreMain.ShowHint(Sender: TObject);
begin
     StatusBar.simpleText := Application.Hint
end;

procedure TSpectreMain.ExitItemClick(Sender: TObject);
begin
  if SauvegardeAfaire and
     (MessageDlg('Sauvegarde',mtConfirmation,[mbYes,mbNo],0)=idYes)  then
        SauveSpectreClick(sender);
  GrapheSpectre.free;
  Close;
end;

procedure TSpectreMain.SauveSpectreClick(Sender: TObject);
var j : indiceVecteur;
    fichier : textFile;
begin with spectro,grapheSpectre do begin
    AssignFile(fichier,FileSaveAs.Dialog.FileName);
    Rewrite(fichier);
    writeln(fichier,'Spectre  '+DateTimeToStr(date+time));
    writeln(fichier,'Lambda',crTab,'A');
    writeln(fichier,'nm',crTab,'');
    for j := debutLambda to finLambda do if
        (valeurY[j]<>sansSignif) then
            writeln(fichier,intToStr(j),crTab,StrAbs(valeurY[j]));
    CloseFile(fichier);
    SauvegardeAfaire := false;
end end; // sauveSpectre

procedure TSpectreMain.AboutItemClick(Sender: TObject);
begin
    AboutBox.ShowModal
end;

procedure TSpectreMain.FormCreate(Sender: TObject);
begin
  Application.OnHint := ShowHint;
  Application.OnMessage := AppMessage;
  GrapheSpectre := Tgraphe.Create;
  GrapheSpectre.etatSpectre := esInit;
  GrapheSpectre.Canvas := PaintBox.Canvas;
  curseur := curNormal;
  Hcommande := 0;
  Hgoto := 0;
  SauvegardeAfaire := false;
  with grapheSpectre do begin
       mondeX.unite := 'nm';
       mondeX.nom := LettreLambda;
       mondeY.nom := 'A';
       mondeY.unite := '';
       with spectro do
            setMonde(MiniLambda,0,MaxiLambda,MaxiAbs);
  end;
  with spectro do begin
       finSE.maxValue := maxiLambda;
       finSE.value := finLambda;
       finSE.minValue := debutLambda+margeLambda;
       debutSE.minValue := miniLambda;
       debutSE.maxValue := finLambda-margeLambda;
       debutSE.value := debutLambda;
       pasLambdaSE.value := pasLambda;
  end;
  PanelLambda.caption := '';
  PanelAbs.caption := '';
end;

procedure TSpectreMain.InitAppareil;

Procedure TestCom(i : integer);
var ET : eventTimer;
    j : integer;
begin
         try { voie Srie }
         voieSerie.comNumber := i;
         voieSerie.Open := true;
         StatusBar.simpleText := 'Recherche du spectro sur COM'+intTostr(i);
         if Hcommande=0 then
            Hcommande := voieSerie.addDataTrigger(spectro.finCommande,false);
         if Hgoto=0 then
            Hgoto := voieSerie.addDataTrigger('OK',false);
         j := 1;
         progressBar1.position := 0;         
         while (j<3) and (GrapheSpectre.etatSpectre=esInit) do begin
             DemandeAbsLambda;
             NewTimerSecs(ET,1);
             repeat
                progressBar1.position := progressBar1.position + 1;
                Application.processMessages;
                sleep(100);
                voieSerie.processCommunications;
             until TimerExpired(ET) or (GrapheSpectre.etatSpectre<>esInit);
             inc(j);
         end;
         case GrapheSpectre.etatSpectre of
            esInit : begin
                if Hcommande<>0 then voieSerie.RemoveTrigger(Hcommande);
                if Hgoto<>0 then voieSerie.RemoveTrigger(Hgoto);
                StatusBar.simpleText := 'Spectro non trouv sur COM'+intTostr(i);
                Hcommande := 0;
                Hgoto := 0;
                VoieSerie.Open := false;
            end;
            esEcho : begin
                if Hcommande<>0 then voieSerie.RemoveTrigger(Hcommande);
                if Hgoto<>0 then voieSerie.RemoveTrigger(Hgoto);
                showMessage('Spectro trouv sur COM'+intTostr(i)+#13+#10+
                             'mais rponse incorrecte : cho ?');
                StatusBar.simpleText := 'Spectro trouv sur COM'+intTostr(i)+' mais ?!';
                Hcommande := 0;
                Hgoto := 0;
                VoieSerie.Open := false;
            end;
            esAttente : begin
               spectro.comNumberS := i;
               StatusBar.simpleText := 'Spectro trouv sur COM'+intTostr(i);
            end;
         end;
         except
            on E : EAPDexception do begin
                 if Hcommande<>0 then voieSerie.RemoveTrigger(Hcommande);
                 if Hgoto<>0 then voieSerie.RemoveTrigger(Hgoto);
                 Hcommande := 0;
                 Hgoto := 0;
                 StatusBar.simpleText := 'Spectro non trouv sur COM'+intTostr(i);
                 VoieSerie.Open := false;
            end;
         end;
end;

var i : integer;
begin with spectro do begin
     screen.cursor := crHourGlass;
     progressBar1.visible := true;
     progressBar1.Max := 30;
     LambdaEnCours := false;
     GotoEnCours := false;
     GrapheSpectre.etatSpectre := esInit;
     PanelLambda.caption := '';
     PanelAbs.caption := '';
     voieSerie.baud := spectro.baud;
     voieSerie.dataBits := spectro.dataBits;
     if isPortAvailable(spectro.comNumberS) then
        testCom(spectro.comNumberS);
     for i := 1 to MaxComHandles do
         if IsPortAvailable(i) and (spectro.comNumberS<>i) then begin
            testCom(i);
            if GrapheSpectre.etatSpectre<>esInit then break;
     end;
     if GrapheSpectre.etatSpectre<>esAttente then
           GrapheSpectre.etatSpectre := esTest;
// en sortie soit esTest soit esAttente
     progressBar1.visible := false;
     connectBtn.visible := GrapheSpectre.etatSpectre=esTest;
     connectMemo.visible := connectBtn.visible;
     screen.cursor := crDefault;
{$IFDEF Debug}
     voieSerie.logging := tlOn;
     voieSerie.tracing := tlOn;
{$ENDIF}
     SetBoutonAcq;
end end; // initAppareil

procedure TSpectreMain.PaintBoxPaint(Sender: TObject);
var z : integer;
begin with grapheSpectre,spectro do begin
        Canvas := PaintBox.Canvas;
        limiteFenetre := PaintBox.clientRect;
        Draw;
        windowXY(debutLambda,0,debutPB,z);
        windowXY(finLambda,0,finPB,z);
        TraceDebutFin;
        TraceUV;
        if etatSpectre=esBlancEnCours then begin
            paintBox.canvas.font.Color := clRed;
            setHauteurFonte(24);
            z := paintBox.canvas.textWidth(TitreBlanc);
            paintBox.canvas.TextOut((paintBox.width-z) div 2,
                                     paintBox.height div 2,TitreBlanc);
        end;
end end;

procedure TSpectreMain.FormClose(Sender: TObject;var Action: TCloseAction);
begin
     if VoieSerie.Tracing=tlOn then VoieSerie.Tracing := tlDump;
     if VoieSerie.Logging=tlOn then VoieSerie.Logging := tlDump;
     VoieSerie.Open := false;
end;

procedure TSpectreMain.RegressiItemClick(Sender: TObject);
begin
     FormDDE.Execute('FOCUS()')
end;

procedure TSpectreMain.RegSaveBtnClick(Sender: TObject);
begin with spectro do begin
    ConstanteDlg.AddColPermis :=
         (oldDebut=debutLambda) and
         (oldFin=finLambda) and
         (oldPas=pasLambda);
    if ConstanteDlg.showModal=mrOk then begin
         FormDDE.EnvoieDonnees;
         oldDebut := debutLambda;
         oldFin := finLambda;
         oldPas := pasLambda;
         SauvegardeAfaire := false;
    end;
end end;

procedure TSpectreMain.SetBoutonAcq;
begin with  GrapheSpectre do begin
     RegSaveAction.enabled := dataOK;
     FileSaveAs.enabled := dataOK;
     case etatSpectre of
         esInit : begin
             Caption := 'Recherche de '+spectro.NomConstructeur;
             StatusBar.simpleText := 'Recherche  en cours';
         end;
         esTest : begin
             Caption := 'Spectro Jenway non trouv';
             StatusBar.simpleText := 'Cliquer sur le bouton Config.';
         end;
         else begin
              Caption := spectro.NomConstructeur+' : trac de spectre pour Regressi';
              StatusBar.simpleText := spectro.NomConstructeur;
         end;
     end;
     stopAction.enabled := etatSpectre in [esBlancEnCours,esSpectreEnCours];
     blancAction.enabled := etatSpectre=esAttente;
     BeerAction.enabled := etatSpectre=esAttente;
     CinetAction.enabled := etatSpectre=esAttente;
     ConfigComAction.enabled := etatSpectre=esTest;
     spectreAction.enabled := (etatSpectre=esAttente) and Spectro.BlancFait;
     PanelBlocage.visible := stopAction.enabled;
     ConfigComAction.visible := etatSpectre=esTest;
     DebutSE.enabled := not StopAction.enabled;
     if etatSpectre=esInit
        then screen.cursor := crHourGlass
        else screen.cursor := crDefault;
end end;

procedure TSpectreMain.BlancActionExecute(Sender: TObject);
var i,largeur : integer;
begin
   if MessageDlg('Mettre la cuve avec le solvant puis "OK"',mtConfirmation,MbOkCancel,0)=mrOK
           then with spectro do begin
            paintBox.canvas.font.Color := clRed;
            satureBtn.Visible := false;
            grapheSpectre.setHauteurFonte(24);
            largeur := paintBox.canvas.textWidth(TitreZero);
            paintBox.canvas.TextOut((paintBox.width -largeur) div 2,
                                     paintBox.height div 2,TitreZero);
            debutLambda := pasLambda*(debutLambda div pasLambda);
            debutSE.value := debutLambda;
            finLambda := pasLambda*round(finLambda div pasLambda);
            if finLambda>MaxiLambda then finLambda := MaxiLambda;
            finSE.value := finLambda;
    // zro  la fin du spectre
            setLambdaLoin(finLambda);
            setZeroProc;
            debutEffectif := debutLambda;
            dec(debutEffectif,2*pasLambda);
   // Premiers points farfelus
            if debutEffectif<miniLambda then debutEffectif := miniLambda;
            setLambdaLoin(debutEffectif);
            spectreAction.enabled := false;
            for i := debutEffectif to finLambda do
               absBlanc[i] := sansSignif;
            GrapheSpectre.etatSpectre := esBlancEnCours;
            setBoutonAcq;
            DemandeAbsLambda;
       end;
end;

procedure TSpectreMain.SpectreBtnClick(Sender: TObject);
var i : integer;
begin
   if sauvegardeAFaire and
     (MessageDlg('Spectre non sauv, on continue ?',
                  mtConfirmation, [mbYes, mbNo], 0) = mrNo) then exit;
   if Application.MessageBox('Mettre la cuve avec l''chantillon puis "OK"',
                             'Spectre Jenway 63xx',MB_OKCANCEL)=mrOK
                 then with spectro do begin
      satureBtn.Visible := false;
      sauvegardeAFaire := false;
      dataOK := false;
      for i := miniLambda to maxiLambda do
          grapheSpectre.valeurY[i] := sansSignif;
      PaintBox.refresh;
      GrapheSpectre.etatSpectre := esSpectreEnCours;
      setBoutonAcq;
      grapheSpectre.mondeY.maxi := maxiAbs;
      debutEffectif := DebutSE.value;
      dec(debutEffectif,2*pasLambda);
// 1ers points farfelus 
      if debutEffectif<MiniLambda then debutEffectif := MiniLambda;
      setLambdaLoin(debutEffectif);
      DemandeAbsLambda;
   end;
end;

procedure TSpectreMain.FormActivate(Sender: TObject);
begin
     if GrapheSpectre.etatSpectre<>esInit then setBoutonAcq;
end;

procedure TSpectreMain.DemandeAbsLambda;
begin
     VoieSerie.flushInBuffer;
     VoieSerie.outPut := spectro.getAbsLambda+spectro.finCommande;
     chaineLue := '';
end;

procedure TSpectreMain.VoieSerieTriggerAvail(CP: TObject; Count: Word);
var i : integer;
    c : char;
begin
    for i := 1 to count do if voieSerie.charReady
           then begin
              C := voieSerie.GetChar;
              if (C=crTab) or (C>' ') then chaineLue := chaineLue+C;
           end;
end;

procedure TSpectreMain.SetLambdaProche(lambda : integer);
var timer : EventTimer;
    compteur : integer;
begin
    voieSerie.output := spectro.gotoLambda+IntToStr(lambda)+spectro.finCommande;
    spectro.LambdaDemandee := lambda;
    if spectro.isFiltreUV then sleep(spectro.TimeOutLambda); // temps de mise en place des filtres
    sleep(spectro.TimeOutLambda); // temps de mise en place de lambda
    GotoEnCours := true;
    compteur := 0;
    repeat
         sleep(100);
         voieSerie.processCommunications;
         inc(compteur);
    until not(gotoEnCours) or (compteur>5);
    if not gotoEnCours then exit;
    // sinon vrification
    compteur := 0;
    GotoEnCours := false;
    repeat  // vrif lambda
       newTimerSecs(timer,1);
       LambdaEnCours := true;
       spectro.resetAbs;
       demandeAbsLambda;
       repeat
          application.ProcessMessages;
          sleep(100);
          voieSerie.processCommunications;
       until not(LambdaEnCours) or
              timerExpired(timer);
       inc(compteur);
    until (lambda=spectro.LambdaCourante) or
          (compteur>1); // deux essais
    LambdaEnCours := false;
    sleep(spectro.TimeOutAbs);
end;

procedure TSpectreMain.SetLambdaLoin(lambda : integer);
var timer : EventTimer;
    compteur : integer;
    lambdaInit : integer;
    timeOut : integer;
begin
    screen.Cursor := crHourGlass;
    newTimerSecs(timer,1);
    LambdaEnCours := true;
    spectro.resetAbs;
    demandeAbsLambda;
    repeat
          application.ProcessMessages;
          sleep(100);
          voieSerie.processCommunications;
    until not(LambdaEnCours) or
          timerExpired(timer);
    lambdaInit := spectro.lambdaCourante;
    if lambdaInit<spectro.MiniLambda then lambdaInit := spectro.MiniLambda; 
    timeOut := abs(lambda-lambdaInit) div 20; // Maxi 40 secondes
    if TimeOut<10 then TimeOut := 10;
    voieSerie.output := spectro.gotoLambda+IntToStr(lambda)+spectro.finCommande;
    spectro.LambdaDemandee := lambda;
    GotoEnCours := true;
    compteur := 0;
    repeat
         sleep(1000);
         voieSerie.processCommunications;
         inc(compteur);
    until not(gotoEnCours) or (compteur>timeOut);
    if not gotoEnCours then exit;
    // sinon vrification
    compteur := 0;
    spectro.resetAbs;
    gotoEnCours := false;
    repeat  // vrif lambda atteinte
       newTimerSecs(timer,1);
       LambdaEnCours := true;
       demandeAbsLambda;
       repeat
          application.ProcessMessages;
          sleep(100);
          voieSerie.processCommunications;
       until not(LambdaEnCours) or
             timerExpired(timer);
       inc(compteur);
    until (spectro.stable) or
          (compteur>1); // deux essais
    LambdaEnCours := false;
    sleep(500);
    screen.Cursor := crDefault;
end;

procedure TSpectreMain.VoieSerieTriggerData(CP: TObject;TriggerHandle: Word);

procedure TriggerSpectre;

procedure AffecteAbsSpectre;
var L : integer;
begin with grapheSpectre,spectro do begin
        if lambdaCourante<finLambda
           then begin
                valeurY[lambdaCourante] := AbsCourante-AbsBlanc[lambdaCourante];
                PanelAbs.caption := 'A='+StrAbs(valeurY[lambdaCourante]);
                PanelLambda.caption := LettreLambda+'='+IntToStr(lambdaCourante)+' nm';
                L := lambdaCourante+pasLambda;
                if L>finLambda then L := finLambda;
                SetLambdaProche(L);
                PaintBox.Refresh;
                DemandeAbsLambda;
           end
           else begin
                MessageBeep(MB_ICONEXCLAMATION);
                valeurY[lambdaCourante] := AbsCourante-AbsBlanc[lambdaCourante];
                PanelAbs.caption := 'A='+StrAbs(valeurY[lambdaCourante]);
                PanelLambda.caption := LettreLambda+'='+IntToStr(lambdaCourante)+' nm';
                etatSpectre := esAttente;
                finLambda := LambdaCourante;
                interpoleSpectre;
                PaintBox.Refresh;
                setBoutonAcq;
                FinSE.minValue := DebutSE.value+margeLambda;
            end;
end end; // affecteAbsSpectre

begin with spectro do begin
  SetAbsLambda(chaineLue);
  satureBtn.Visible := spectro.sature;
  if (lambdaCourante=LambdaDemandee) and stable
      then AffecteAbsSpectre
      else if lambdaCourante>finLambda
          then begin
              grapheSpectre.etatSpectre := esAttente;
              spectreAction.enabled := blancFait;
              setBoutonAcq;
          end
          else begin
             if faireGoto
                then SetLambdaProche(lambdaDemandee)
                else sleep(TimeOutAbs);
             DemandeAbsLambda
          end;
end end; // TriggerSpectre

procedure TriggerBlanc;
var L : integer;
begin with spectro do begin
    SetAbsLambda(chaineLue);
    satureBtn.Visible := spectro.sature;
    if (lambdaCourante=LambdaDemandee) and stable
       then begin
           AbsBlanc[lambdaCourante] := AbsCourante;
           if lambdaCourante<finLambda
              then begin
                  PanelLambda.caption := LettreLambda+'='+IntToStr(lambdaCourante)+' nm';
                  PanelAbs.caption := 'A='+StrAbs(absCourante);
                  L := lambdaCourante+pasLambda;
                  if L>finLambda then L := finLambda;
                  setLambdaProche(L);
                  demandeAbsLambda;
              end
              else begin
                 MessageBeep(MB_ICONEXCLAMATION);
                 PanelLambda.caption := LettreLambda+'='+IntToStr(lambdaCourante)+' nm';
                 PanelAbs.caption := 'A='+StrAbs(absCourante);
                 interpoleBlanc;
                 GrapheSpectre.etatSpectre := esAttente;
                 setBoutonAcq;
                 PaintBox.Refresh;
              end
       end
       else begin
            if faireGoto
               then SetLambdaProche(lambdaDemandee)
               else sleep(TimeOutAbs);
            demandeAbsLambda
      end;
end end; // TriggerBlanc

begin
     if TriggerHandle=hGoto then gotoEnCours := false
// pas une bonne ide mais OK[0D] renvoie parfois OK et parfois OK[0D] 
     else if gotoEnCours then exit
     else if LambdaEnCours then begin
         spectro.SetAbsLambda(chaineLue);
         satureBtn.Visible := spectro.sature;
         if spectro.lambdaCourante<>0 then begin
            PanelLambda.caption := LettreLambda+'='+IntToStr(spectro.lambdaCourante)+' nm';
            PanelAbs.caption := '';
         end;   
         LambdaEnCours := false
     end
     else case GrapheSpectre.etatSpectre of
        esSpectreEnCours : TriggerSpectre;
        esBlancEnCours : TriggerBlanc;
        esAbsorbance : begin
            spectro.setAbsorbance(chaineLue);
            GrapheSpectre.etatSpectre := esAttente;
        end;
        esAttente : ;
        esInit : if length(chaineLue)>2
           then GrapheSpectre.etatSpectre := esAttente
           else if chaineLue='A' then GrapheSpectre.etatSpectre := esEcho;
        // echo A (convertisseur USB srie) ?
        esTest : ;
        esEcho : ;
     end;
end; // TriggerData

procedure TSpectreMain.BornesChange(Sender: TObject);
begin
     if DebutSE.enabled then TraceDebutFin;
     if sender=finSE then begin
         DebutSE.maxValue := FinSE.value-margeLambda;
         spectro.FinLambda := FinSE.value;
     end;
     if DebutSE.enabled
        then begin
           if sender=debutSE then begin
                FinSE.minValue := DebutSE.value+margeLambda;
                spectro.DebutLambda := DebutSE.value;
           end;
        end
        else FinSE.minValue := spectro.LambdaDemandee+10;
     spectreAction.enabled := (GrapheSpectre.etatSpectre=esAttente) and
                               Spectro.BlancFait;
     if DebutSE.enabled then TraceDebutFin;
end;

procedure TSpectreMain.InterpoleSpectre;
begin
    dataOK := (spectro.finLambda-spectro.debutLambda)>16;
    sauvegardeAFaire := dataOK;
    if dataOK then grapheSpectre.MondeY.Maxi := grapheSpectre.maxiY;
end;

procedure TSpectreMain.InterpoleBlanc;
var i,j : integer;
    ecart1,ecart2 : double;
begin with grapheSpectre,spectro do begin
     for i := debutEffectif to finLambda do
         if absBlanc[i]=sansSignif then begin
            j := i;
            repeat inc(j) until (j>=finLambda) or
               (absBlanc[j]<>sansSignif);
            if absBlanc[j]=sansSignif
               then absBlanc[i] := absBlanc[i-1]
               else absBlanc[i] := absBlanc[i-1]+
                    (absBlanc[j]-absBlanc[i-1])/(j-i+1)
         end;
     for i := succ(debutLambda) to pred(finLambda) do begin
         ecart1 := (absBlanc[succ(i)]-absBlanc[i]);
         ecart2 := (absBlanc[pred(i)]-absBlanc[i]);
         if (ecart1*ecart2>0) and
            (abs(ecart1)>0.02) and
            (abs(ecart2)>0.02)
               then absBlanc[i] := (absBlanc[succ(i)]+absBlanc[pred(i)])/2
    end;
    spectreAction.enabled := spectro.blancFait;
end end;

procedure TSpectreMain.PaintBoxMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
var xr,yr : double;
    L  : integer;
begin with grapheSpectre,spectro do begin
     mondeXY(x,y,xr,yr);
     L := round(xr);
     case curseur of
         curNormal : if not (etatSpectre in [esBlancEnCours,esSpectreEnCours]) then begin
             if dataOK then if (L>=debutLambda) and (L<=finLambda)
                 then begin
                      while (valeurY[L]=sansSignif) and (L<finLambda) do inc(L);
                      PanelAbs.caption := 'A='+StrAbs(valeurY[L]);
                      PanelLambda.caption := LettreLambda+'='+IntToStr(L)+' nm';
                      grapheSpectre.afficheCroix(L,valeurY[L]);
                 end
                 else begin
                      PanelAbs.caption := 'A='+StrAbs(yr);
                      PanelLambda.caption := LettreLambda+'='+IntToStr(L)+' nm';
                      grapheSpectre.afficheCroix(L,0);
                 end
              else grapheSpectre.afficheCroix(600,0);
              if (abs(x-debutPB)<3) and debutSE.Enabled
                  then cursor := crHsplit
                  else if (abs(x-finPB)<3)
                       then cursor := crHsplit
                       else cursor := crDefault;
         end; // pas spectre en cours
         curDebut : if (X>limiteCourbe.left) and
                       (X<finPB) then begin
                traceDebutFin; // efface l'ancien 
                debutLambda := L;
                traceDebutFin;
                affecteDebutFin;
                cursor := crHsplit;
         end;
         curFin : if (X>debutPB) and
                     (X<limiteCourbe.right) then begin
               traceDebutFin; // efface l'ancien
               FinLambda := L;
               traceDebutFin;
               affecteDebutFin;
               cursor := crHsplit;
         end;
     end;{case}
end end;

procedure TSpectreMain.PasLambdaSEChange(Sender: TObject);
begin
   spectro.PasLambda := pasLambdaSE.value
end;

procedure TSpectreMain.ConfigComActionExecute(Sender: TObject);
begin
    if Hcommande<>0 then voieSerie.RemoveTrigger(Hcommande);
    if Hgoto<>0 then voieSerie.RemoveTrigger(Hgoto);
    Hcommande := 0;
    Hgoto := 0;
    if ChoixSpectroDlg.ShowModal=mrOK then begin
       grapheSpectre.mondeX.mini := spectro.MiniLambda;
       debutSE.MinValue := spectro.MiniLambda;
       initAppareil;
    end;
end;

procedure TSpectreMain.ConnectBtnClick(Sender: TObject);
begin
     InitAppareil;
end;

procedure TSpectreMain.PaintBoxMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
   if abs(x-debutPB)<3
      then if debutSE.Enabled
           then curseur := curDebut
           else curseur := curNormal
      else if abs(x-finPB)<3
         then curseur := curFin
         else curseur := curNormal;
   if curseur=curNormal
       then cursor := crDefault
       else cursor := crHsplit;
end;

procedure TSpectreMain.PaintBoxMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var xx,yy : double;
begin with spectro do begin
      traceDebutFin;
      case curseur of
           curDebut : if X<(finPB-margeLambda) then begin
               grapheSpectre.mondeXY(x,0,xx,yy);
               DebutLambda := round(xx);
           end;
           curFin : if X>(debutPB+margeLambda) then begin
               grapheSpectre.mondeXY(x,0,xx,yy);
               FinLambda := round(xx);
           end;
      end;
      if debutLambda<miniLambda then
           debutLambda := miniLambda;
      if finLambda>maxiLambda then
           finLambda := maxiLambda;
      if finLambda<(debutLambda+margeLambda) then
           finLambda := debutLambda+margeLambda;
      curseur := curNormal;
      cursor := crDefault;
      traceDebutFin;
      affecteDebutFin;
      paintBox.refresh;
end end;

procedure TspectreMain.TraceDebutFin;
var z : integer;
begin with grapheSpectre,PaintBox.Canvas do begin
      Pen.Color := clRed;
      Pen.mode := pmNot;
      Pen.style := psSolid;
      Pen.width := 2;
      windowXY(spectro.debutLambda,0,debutPB,z);
      windowXY(spectro.finLambda,0,finPB,z);
      MoveTo(debutPB,0);
      LineTo(debutPB,Height);
      MoveTo(finPB,0);
      LineTo(finPB,Height);
end end;

procedure TspectreMain.TraceUV;
var UV1PB,UV2PB,z : integer;
begin with grapheSpectre,PaintBox.Canvas do begin
      Pen.Color := clBlue;
      Pen.mode := pmCopy;
      Pen.style := psDot;
      Pen.width := 1;
      windowXY(filtres[spectro.jenway,1],0,UV1PB,z);
      windowXY(filtres[spectro.jenway,2],0,UV2PB,z);
      MoveTo(UV1PB,0);
      LineTo(UV1PB,Height);
      if UV2PB<paintBox.width then begin
         MoveTo(UV2PB,0);
         LineTo(UV2PB,Height);
      end;   
end end;

procedure TspectreMain.AffecteDebutFin;
begin with spectro do begin
   debutSE.value := debutLambda;
   finSE.value := finLambda;
   finSE.minValue := debutLambda+margeLambda;
   debutSE.maxValue := finLambda-margeLambda;
   spectreAction.enabled := (GrapheSpectre.etatSpectre=esAttente) and
                            Spectro.BlancFait;
end end;

procedure TSpectreMain.setZeroProc;
var ET : eventTimer;
    compteur,compteurBis : integer;
begin
    if (spectro.Jenway=j6315) then begin
         showMessage('Effectuer le zro sur le spectro');
         exit;
    end;
    screen.Cursor := crHourGlass;
    compteurBis := 0;
    repeat
       voieSerie.Output := spectro.setZero+spectro.finCommande;
       sleep(spectro.TimeOutLambda);
       compteur := 0;
       spectro.resetAbs;
       repeat
          newTimerSecs(ET,1);
          LambdaEnCours := true;
          demandeAbsLambda;
          repeat
             application.ProcessMessages;
             sleep(100);
             voieSerie.processCommunications;
          until not(LambdaEnCours) or
              timerExpired(ET);
          inc(compteur);
       until spectro.stable or (compteur>5);
       inc(compteurBis);
    until (spectro.absCourante=0) or (compteurBis>2);
    screen.Cursor := crDefault;
end;

{
MessageBeep(
MB_ICONASTERISK	SystemAsterisk
MB_ICONEXCLAMATION	SystemExclamation
MB_ICONHAND	SystemHand
MB_ICONQUESTION	SystemQuestion
MB_OK
}

procedure TSpectreMain.StopActionExecute(Sender: TObject);
var j : integer;
begin with spectro do begin
     if GrapheSpectre.etatSpectre=esSpectreEnCours then begin
           j := spectro.lambdaCourante; // au cas o dernire mesure pas encore stabilise
           while (j<spectro.debutLambda) and
                 (GrapheSpectre.valeurY[j]=sansSignif) do dec(j);
           if (j-debutLambda)>((finLambda-debutLambda) div 2) then begin
               spectro.finLambda := j;
               FinSE.value := j;
           end;
           interpoleSpectre;
     end;
     if GrapheSpectre.etatSpectre=esBlancEnCours then begin
           j := spectro.lambdaCourante; // au cas o dernire mesure pas encore stabilise
           while (j<spectro.debutLambda) and
                 (spectro.absBlanc[j]=sansSignif) do dec(j);
           if (j-debutLambda)>((finLambda-debutLambda) div 2) then begin
               spectro.finLambda := j;
               FinSE.value := j;
           end;
           InterpoleBlanc;
     end;
     GrapheSpectre.etatSpectre := esAttente;
     setBoutonAcq;
end end;

function TSpectreMain.getAbsorbance : double;
var ET : eventTimer;
begin
     GrapheSpectre.etatSpectre := esAbsorbance;
     DemandeAbsLambda;
     NewTimerSecs(ET,1);
     repeat
           Application.processMessages;
           sleep(100);
           voieSerie.processCommunications;
     until TimerExpired(ET) or (GrapheSpectre.etatSpectre=esAttente);
     if GrapheSpectre.etatSpectre=esAttente
        then result := spectro.AbsCourante
        else result := sansSignif;
end;

procedure TSpectreMain.FileOpenAccept(Sender: TObject);
var LigneTampon : shortString;
    Fichier : textFile;
    FinFichier : boolean;

procedure litLigne;
begin
   if finFichier
      then ligneTampon := ''
      else begin
              try
              readln(Fichier,ligneTampon);
              finFichier := eof(fichier);
              except
                 finFichier := true
              end;
      end
end;

Procedure ExtraitValeur;
var posTab : integer;
    i : integer;
begin
    try
    litLigne;
    posTab := pos(crTab,ligneTampon);
    if posTab=0 then exit;
    i :=  strToInt(copy(ligneTampon,1,posTab-1));
    grapheSpectre.valeurY[i] :=  strToFloat(copy(ligneTampon,posTab+1,length(ligneTampon)-posTab));
    except
    end;
end; {extraitValeur}

var i : integer;
begin
   assignFile(fichier,FileOpen.Dialog.FileName);
   Reset(fichier);
   for i := spectro.miniLambda to spectro.maxiLambda do
       grapheSpectre.valeurY[i] := sansSignif;
   spectro.debutLambda := spectro.miniLambda;
   spectro.finLambda := spectro.maxiLambda;
   finFichier := false;
   litLigne; // titre
   litLigne; // lambda Abs
   litLigne; // unit
   while not finFichier do extraitValeur;
   i := spectro.miniLambda;
   while (grapheSpectre.valeurY[i]=sansSignif) and
         (i<spectro.maxiLambda) do inc(i);
   spectro.debutLambda := i;
   i := spectro.maxiLambda;
   while (grapheSpectre.valeurY[i]=sansSignif) and
         (i>spectro.debutLambda) do dec(i);
   spectro.finLambda := i;
   closeFile(Fichier);
   paintBox.refresh;
end; // File Open

procedure TSpectreMain.SetMode(Acq : Tmode);
begin
     constanteDlg.newPageCB.itemIndex := 0;
     SpectreAction.enabled := Acq in [mNone,mSpectre];
     CinetAction.enabled := Acq in [mNone,mCinetique];
     BeerAction.enabled := Acq in [mNone,mBeer];
     AcquisitionEnCours := Acq;
end;

procedure TSpectreMain.CinetActionExecute(Sender: TObject);
begin
    setMode(mCinetique);
    CinetiqueForm.show;
end;

procedure TSpectreMain.BeerActionExecute(Sender: TObject);
begin
    setMode(mBeer);
    BeerForm.show;
end;

procedure TSpectreMain.ClipMClick(Sender: TObject);
begin
    FormDDE.SpectreClipBoard
end;

procedure TSpectreMain.Quitter1Click(Sender: TObject);
begin
  close
end;

end.


