unit Spectdde;

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, DdeMan, ExtCtrls, Registry,
  specmain, cfgSpect, graphker, jmmUtil, inifiles, clipBrd;

type
  TFormDDE = class(TForm)
    ClientDDE: TDdeClientConv;
    ClientItem: TDdeClientItem;
    ServeurDDE: TDdeServerConv;
    procedure FormDestroy(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ExecuteMacro(Sender: TObject; Msg: TStrings);
  private
    NumeroSpectre : integer;
  public
    procedure AjouteConst(var donnees : TstringList);
    procedure Execute(Ordre : shortString);
    procedure EnvoieDonnees;
    procedure SpectreClipBoard;    
    procedure EnvoieDonneesCinetique(DDE : boolean);
  end;

var
  FormDDE: TFormDDE;

implementation

uses JenwayConst, JenwayCinet;

{$R *.DFM}

procedure TFormDDE.AjouteConst(var donnees : TstringList);
begin with constanteDlg do
     if avecConstante then begin
        try
            Donnees.Add('');
            Donnees.Add(NomConstEdit.text);
            Donnees.Add(UniteConstEdit.text);
            Donnees.Add(ValeurConstEdit.text);
        except
        end;
     end;
end;

procedure TFormDDE.Execute(Ordre : shortString);
var NomCourt : shortString;

Procedure lanceRegressi;
var hSemaphore : integer;
    CharVal: array[0..1024] of Char;
begin
   StrPCopy(CharVal, NomCourt);
   hSemaphore := CreateSemaphore(nil,0,1,CharVal);
   if (hSemaphore<>0) and
      (GetLastError = Error_Already_Exists) then exit;
   StrPCopy(CharVal, ClientDde.ServiceApplication);
   if WinExec(CharVal, SW_SHOWDEFAULT) >= 32 then sleep(2000);
end;

procedure Lance;
var Buf: PChar;
begin
      Buf := StrAlloc(Succ(Length(Ordre)));
      if not ClientDDE.ExecuteMacro(StrPCopy(Buf,Ordre), false) then
           ShowMessage(Ordre+' non excut');
      StrDispose(Buf);
      ClientDDE.closeLink;
end;

begin
     NomCourt := AnsiUpperCase(ExtractFileName(ClientDDE.ServiceApplication));
     NomCourt := ChangeFileExt(NomCourt,'');
     LanceRegressi;
     ClientDDE.SetLink(NomCourt,'ServeurDDE');
     ClientItem.DDEItem := 'ServeurItem';
     if ClientDDE.OpenLink
        then Lance
        else begin
        // OpenLik false efface 
             ClientDDE.SetLink(NomCourt,'ServeurDDE');
             ClientItem.DDEItem := 'ServeurItem';
             sleep(1000);
             if ClientDDE.OpenLink
                then Lance
                else ShowMessage('Impossible de lancer '+nomCourt);
        end;
end;

procedure TFormDDE.FormDestroy(Sender: TObject);
begin
     ClientDDE.CloseLink
end;

procedure TFormDDE.EnvoieDonnees;
var donnees : TstringList;

procedure EnvoiePageSpectre;
var i : indiceVecteur;
begin with spectreMain,grapheSpectre,spectro do begin
     Donnees.Clear;
     numeroSpectre := 1;
     Donnees.Add(Application.ExeName);
     Donnees.Add(ConstanteDlg.CommEdit.text+' spectre '+DateTimeToStr(date+time));
     Donnees.Add(LettreLambda+crTab+'A');
     Donnees.Add('nm'+crTab+'');
     for i := debutLambda to finLambda do
        if (valeurY[i]<>sansSignif) then
           Donnees.Add(intToStr(i)+crTab+StrAbs(valeurY[i]));
     if ConstanteDlg.NomConstEdit.text<>'' then begin
        Donnees.Add('');
        Donnees.Add(ConstanteDlg.NomConstEdit.text);
        Donnees.Add(ConstanteDlg.UniteConstEdit.text);
        Donnees.Add(ConstanteDlg.ValeurConstEdit.text);
     end;
     ClipBoard.AsText := Donnees.text;
end end;

procedure EnvoieColonneSpectre;
var i : indiceVecteur;
begin with spectreMain,grapheSpectre,spectro do begin
     Donnees.Clear;
     inc(numeroSpectre);
     Donnees.Add('');
     Donnees.Add('A'+intToStr(numeroSpectre)+crTab);
     Donnees.Add(''+crTab);
     Donnees.Add(ConstanteDlg.CommEdit.text+crTab);
     for i := debutLambda to finLambda do
         if valeurY[i]<>SansSignif then
            Donnees.Add(StrAbs(valeurY[i]));
     ClipBoard.AsText := Donnees.text;
end end;

begin
     Donnees := TstringList.create;
     case ConstanteDlg.modeRegressi of
          rFichier : begin
             envoiePageSpectre;
             Execute('CLIP|LOAD');
          end;
          rPage : begin
             envoiePageSpectre;
             Execute('CLIP|ADD');
          end;
          rColonne : begin
             envoieColonneSpectre;
             Execute('CLIP|ADDCOL');
          end;
     end;
     if ConstanteDlg.NewPageCB.itemIndex=0 then
         ConstanteDlg.NewPageCB.itemIndex := 1;
     Donnees.free;
end;

procedure TFormDDE.SpectreClipBoard;
var donnees : TstringList;
    i : indiceVecteur;
begin
     Donnees := TstringList.create;
     Donnees.Clear;
     Donnees.Add(LettreLambda+crTab+'A');
     Donnees.Add('nm'+crTab+'');
     with spectreMain,grapheSpectre,spectro do
     for i := debutLambda to finLambda do
         if (valeurY[i]<>sansSignif) then 
             Donnees.Add(intToStr(i)+crTab+StrAbs(valeurY[i]));
     ClipBoard.AsText := Donnees.text;
     Donnees.free;
end;

procedure TFormDDE.ExecuteMacro(Sender: TObject; Msg: TStrings);

function GetArgs(const BufStr: shortString): shortString;
var ArgStart, ArgEnd: byte;
begin
  { recherche parenthses ouvrante et fermante : fonction(argument) }
  ArgStart := Pos('(', BufStr);
  ArgEnd := Pos(')', BufStr);
  if (ArgStart >= ArgEnd)
     then result := ''
     else result := Copy(BufStr, Succ(ArgStart), ArgEnd - Succ(ArgStart));
end;

function GetFnName(const BufStr: shortString): shortString;
var OpenBracketPos: byte;
begin
  OpenBracketPos := Pos('(', BufStr);
  if (OpenBracketPos <= 0)
     then result := BufStr
     else result := Copy(BufStr, 1, Pred(OpenBracketPos));
end;

var Fonction,NomFichier : shortString;
begin
     if (Msg.Count = 1) then begin
       try
       NomFichier := GetArgs(Msg[0]);
       Fonction := GetFnName(Msg[0]);
       if CompareText('CONFIG|LOAD',Fonction) = 0 then begin
           exit
       end;
       if CompareText('CONFIG|SAVE',Fonction) = 0 then begin
           exit
       end;
       if CompareText('FOCUS',Fonction) = 0 then begin
           SpectreMain.setFocus;
           exit;
       end;
       if CompareText('GETDATA',Fonction) = 0 then begin
           SpectreMain.setFocus;
           exit;
       end;
       except
       end;
     end
end;

procedure TFormDDE.FormCreate(Sender: TObject);
var Ini : TRegIniFile;
begin
    Ini := TRegIniFile.create('Software');
    ClientDDE.ServiceApplication := Ini.ReadString('Regressi','Path','');
    Ini.Free;
    Ini := TRegIniFile.create('Software\Regressi');
    ClientDDE.ServiceApplication := Ini.ReadString('Regressi','Path',ClientDDE.ServiceApplication);
    Ini.Free;
    if ClientDDE.ServiceApplication='' then
       ClientDDE.ServiceApplication := 'regressi.exe';
    ClientItem.DDEItem := 'ServeurItem';
end;

procedure TFormDDE.EnvoieDonneesCinetique(DDE : boolean);
var i : indiceVecteur;
    repere : Trepere;
    donnees : TstringList;
begin with CinetiqueForm,graphe do begin
     Donnees := TstringList.create;
     Donnees.Add(Application.ExeName);
     Donnees.Add('Cintique  '+DateTimeToStr(date+time));
     Donnees.Add(ConstanteDlg.CommEdit.text);
     Donnees.Add(MondeX.nom+crTab+MondeY.nom);
     Donnees.Add(MondeX.unite+crTab+MondeY.unite);
     for i := 0 to pred(NbrePoints) do begin
         Donnees.Add(FloatToStrPoint(valeurX[i])+crTab+
           FloatToStrPoint(valeurY[i]));
     end;
     AjouteConst(donnees);
     if ListeRepere.count>0 then begin
         Donnees.Add(symbReg2+IntToStr(ListeRepere.count)+' REPERE');
         for i := 0 to pred(ListeRepere.count) do begin
             repere := Trepere(listeRepere[i]);
             Donnees.Add(FloatToStrPoint(repere.valeur)+crTab+repere.text);
         end;
     end;
     ClipBoard.AsText := donnees.text;
     if DDE then if constanteDlg.newPageCB.itemIndex=1
        then Execute('CLIP|ADD()')
        else Execute('CLIP|LOAD()');
     donnees.free;
     constanteDlg.newPageCB.itemIndex := 1;
end end;

end.
